****************************************************************
*   func1.prg
*   allg. Funktionen Sima/Fibu
*
*   SINUS Messtechnik GmbH, K. Gedicke
*   Stand: 21.12.2001
****************************************************************

#include "sima.ch"
//#include "sf_text.ch"

/*
 * Fgen Sie die Define-Konstante USE_POSTGRES zu Ihren Projekt-Einstellungen -> Compiler
 * -> Define-Konstanten hinzu, um den PostgreSQL-Server anstatt der dbf-Tabellen und
 * -Indexe (dbf/cdx) zu verwenden.
 */
#ifdef USE_POSTGRES
#include "pgdbe.ch"
#endif

*************************
PROC ProgInit(cProgName)
LOCAL cDrive:=UPPER(CurDrive("c")), cDir:=CurDir("C:\sima\Test\SIMAPG"), x_dok_str:="", xdname:="", xdpath:="", xdpos1:=1, xdpos2:=999
#ifdef USE_POSTGRES
LOCAL cConnStr
#endif

PUBLIC oDBServerSession, oCrt, oFont
PUBLIC lAppRun := .t.               // Programm beenden, wenn .F.
SET TYPEAHEAD TO 100

SET EPOCH TO 1990
SET DATE FORMAT "dd.mm.yy"
SET SCOREBOARD OFF
SET DELETED ON

READINSERT(.T.)

PUBLIC  programname:=cProgName
PUBLIC  programversion:="4.0A"   // s. auch M.BAT & T.BAT
PUBLIC  farbe0:= ""   // := SETCOLOR() nach MyAppSys()
PUBLIC  farbe1:= "BG+/B, GR+/BG,, GR+/B, N/BG"
PUBLIC  farbe2:= "N/BG, GR+/W,,, N/W"
PUBLIC  farbe3:= "W+/BG, GR+/W,,, N/W"
PUBLIC  farbe4:= "N/W, GR+/BG,,, N/BG"
PUBLIC  farbe5:= "W+/RB"
PUBLIC  farbe6:= "GR+/W"
PUBLIC  farbe7:= "GR+/BG"
PUBLIC  farbe8:= "W+/BG, W+/N, GR+/BG, W+/N, N+/W, N/BG"     //Men
PUBLIC  ne1:="Satz sperren z.Z. unmglich"
PUBLIC  ne2:="Satz hinzufgen z.Z. unmglich"
PUBLIC  ne3:="Datei sperren z.Z. unmglich"
PUBLIC  ne4:="ffnen nicht mglich: "
PUBLIC  ne5:="Datei existiert nicht: "
PUBLIC  cr:=CHR(13)+CHR(10)           //CR+LF
PUBLIC  jn:={"Ja","Nein"}             //fr alle ALERT()'s
PUBLIC  nj:={"Nein","Ja"}
PUBLIC  oeb:=ERRORBLOCK({|oerr| myErrorH(oerr, oeb)})   //alle Error-Ausgabe in wselect(0) umleiten
PUBLIC  oMenuBar
PUBLIC  temp_path:=""                 //Verz. fr temp. Dateien
PUBLIC  dok_path:=""                  //Verz. fr Druck-Dateien
PUBLIC  x_dok_names:={}               //x_dok_path ist erweitertes Verz. fr Druck-Dateien: Namenanfang1*Verz1*Namenanfang2*Verz2*...
PUBLIC  x_dok_paths:={}
PUBLIC  ab_path:=""                   //Verz. fr Auftragsbesttigungen
PUBLIC  db_path:=""                   //Verz. fr Datenbltter
PUBLIC  si_path:=""
PUBLIC  lk_path:=""
PUBLIC  ls_path:=""
PUBLIC  be_path:=""
PUBLIC  fbk_path:=""
PUBLIC  sl_path:=""                   //Verz. Stcklisten (nur SIMA)
PUBLIC  fibu_path:=""                 //Haupt-Datenverzeichnis FIBU
PUBLIC  ang_path:=""                  //Verz. Angebote (nur FIBU)
PUBLIC  auf_order:=""
PUBLIC  auf_def_lt:=""
PUBLIC  auf_def_lt_anr:=0
PUBLIC  auf_def_wt:=""
PUBLIC  auf_def_wt_anr:=0
PUBLIC  cWinDrucker:=""
PUBLIC  oXbpPrinter:=NIL
PUBLIC  cPrinter:=""
PUBLIC  lprmode:=.f.   //.f. normal, .t. Test=Druck in Datei prnfile.txt
PUBLIC  aPP[13]        //Feld fr Drucker-Steuerbefehle
PUBLIC  nrFibu:=0 //er,ar,ueb,bv,ks - Zugriffsrechte
PUBLIC  nrArt:=0  //Artikel
PUBLIC  nrSl:=0   //Produkte/ Stcklisten
PUBLIC  nrMp:=0   //Materialprojekte/ Bestellungen
PUBLIC  nrLs:=0   //Lieferschein
PUBLIC  nrLk:=0   //Adressdatei
PUBLIC  nrLo:=0   //Lagerort
PUBLIC  nrAng:=0  //Angebote
PUBLIC  nrAuf:=0  //Auftrge
PUBLIC  nrFa:=0   //Fertigungsauftrge
PUBLIC  lHelp:=.f.//Rechte: Schreibrecht fr Hilfe
PUBLIC  lSup:=.f. //Supervisor-Recht
PUBLIC  netuser:=""
PUBLIC  username:=""
PUBLIC  systextuser:="ZZZZ"
PUBLIC  tk:=SF_TEXT                   //aus sf_text.ch
PUBLIC  defPGUP:=SETKEY(K_PGUP)        //Originalbelegung "Page Up"
PUBLIC  defPGDN:=SETKEY(K_PGDN)        //Originalbelegung "Page Down"
PUBLIC  cFontFile:="C:\sima\Test\SIMAPG\FONT.BIN"
PUBLIC  nLenFirma1:=0   // LEN(lk->firma1), in lk_open() initialisiert
PUBLIC  nLenAdrDisplay:=32  //Umschlagsfensterbreite
PUBLIC  nLenEmailDisplay:=32
PUBLIC  AppMaxRow:=24
PUBLIC  AppMaxCol:=79
#ifdef GUI
PUBLIC  AppMaxRow := 39
#endif

programname := "X" + programname

//Konfig.-Datei lesen
IF !FILE(cConfig)
    MyAppSys()
    ALERT("Parameter fehlt: Konfig.-Datei")
    Quit_App()
END
cConfigText := MEMOREAD(cConfig)

#ifdef GUI
AppMaxRow := MAX(VAL(getKey(@cConfigText, "rows", STR(AppMaxRow)))-1, 24)
AppMaxCol := MAX(VAL(getKey(@cConfigText, "cols", STR(AppMaxCol)))-1, 79)
#endif
MyAppSys()
IF cDrive > "G"       // ADS-Fehler 5018 (AE_INVALID_HANDLE) vermeiden
    ALERT("Achtung! Akt. Laufwerk " + cDrive + ": - kann zu Datebankfehlercode 5018 fhren!;" +;
          "Bitte im Verzeichnis C:\sima\Test\SIMAPG starten (s. Verknpfungseinstellungen).")
END

//Pfade festlegen
fibu_path := getKey(@cConfigText, "fibu_path")
si_path   := getKey(@cConfigText, "si_path")
lk_path   := getKey(@cConfigText, "lk_path")
ls_path   := getKey(@cConfigText, "ls_path")
be_path   := getKey(@cConfigText, "be_path")
fbk_path  := getKey(@cConfigText, "fbk_path")
IF cProgName=="SIMAWI"
    sl_path := getKey(@cConfigText, "sl_path")
END
temp_path := getKey(@cConfigText, "temp_path")
dok_path  := getKey(@cConfigText, "dok_path", temp_path)
ab_path   := getKey(@cConfigText, "ab_path", "W:\SIMA\AB")   //Auftragsbesttigungen
db_path   := getKey(@cConfigText, "db_path", "W:\SIMA\DB")   //Datenbltter

x_dok_str := ALLTRIM(getKey(@cConfigText, "x_dok_path", ""))
WHILE xdpos1 < LEN(x_dok_str)   // x_dok_path ist erweitertes Verz. fr Druck-Dateien: Namenanfang1*Verz1*Namenanfang2*Verz2*...
    xdpos2 := AT("*", x_dok_str, xdpos1)
    IF xdpos2 <= xdpos1
        EXIT
    END
    xdname := UPPER(ALLTRIM(SUBSTR(x_dok_str, xdpos1, xdpos2 - xdpos1)))
    xdpos1 := xdpos2 + 1
    xdpos2 := AT("*", x_dok_str, xdpos1)
    IF xdpos2 == 0
        xdpos2 := LEN(x_dok_str) + 1
    END
    xdpath := ALLTRIM(SUBSTR(x_dok_str, xdpos1, xdpos2 - xdpos1))
    IF EMPTY(xdname) .OR. EMPTY(xdpath)
        EXIT
    END
    AADD(x_dok_names, xdname)
    AADD(x_dok_paths, xdpath)
    xdpos1 := xdpos2 + 1
END

auf_order := getKey(@cConfigText, "auf_order", "anr")        //Auftragsreihenfolge

cWinDrucker := ALLTRIM(getKey(@cConfigText, "win_drucker", ""))
IF !EMPTY(cWinDrucker)
    oXbpPrinter := XbpPrinter():New()
    oXbpPrinter:Create(cWinDrucker)
END
cPrinter := UPPER(getKey(@cConfigText, "printer"))
lprmode  := (cPrinter=="FILE")
IF lprmode
    SET PRINTER TO prnfile.txt
ELSE
    SetPrinterTo()
END

#ifdef USE_POSTGRES
    cDBECDX := "PGDBE"
    _DBeSetDefault(cDBECDX)

    //TODO Connection data in .cfg file...
    cConnStr := "DBE=pgdbe;server=172.20.1.8;"
    cConnStr += "db=sima;uid=mac;pwd=sinus"

    oDBServerSession := DacSession():New(cConnStr)
    IF(!oDBServerSession:IsConnected())
      MsgBox("Verbindung fehlgeschlagen ("+Var2Char(oSession:GetLastMessage())+")")
      QUIT
    ENDIF

    //MsgBox("Verbindung mit PostgreSQL-Server erfolgreich")
#else
    // ADS DacSesion starten
    oDBServerSession:=_ADSSession(si_path)
#endif

farbe0 := SETCOLOR()

// Druckersequenzen festlegen (Feld aPP mit Steuercodes fr Printer belegen)
DO CASE
    CASE cPrinter=="FILE"
        aPP[1] := {|n| SPACE(n) }
        AFILL(aPP,"",2,12)

    CASE cPrinter=="HPLJ"
        aPP:={ {|n| CHR(27)+"&a"+LTRIM(STR(n,6))+"L"},; //[1] linker Rand
               "",;                                     //[2] Draft
               "",;                                     //[3] Letter
               CHR(27) + "&k2S",;                       //[4] 16.6cpi
               CHR(27) + "&k0S",;                       //[5] 10cpi
               CHR(27) + "&k2S",;                       //[6] 16.6cpi
               CHR(27) + "&k0S",;                       //[7] 10cpi
               "",;                                     //[8] Quick Gotic 12
               "",;                                     //[9] Courier 10
               cr + cr,;                                //[10] oberer Rand (2 Leerzeilen)
               CHR(27) + "(s3B",;                       //[11] Fett ein
               CHR(27) + "(s0B",;                       //[12] Fett aus
               CHR(27) + "(10U";                        //[13] Init, Zeichensatz
             + CHR(27) + "(s0p10h12v0s0b3T" }

    CASE cPrinter=="IBMPP"
        aPP:={ {|n| CHR(27)+CHR(91)+CHR(83)+CHR(8)+CHR(0);
                   +CHR(3)+CHR(96);
                   +CHR(55)+CHR(80);
                   +CHR(INT(n*144/256))+CHR(INT(256*((n*144)%256)));
                   +CHR(43)+CHR(152) },;                //[1] linker Rand
               "",;                                     //[2] Draft
               "",;                                     //[3] Letter
               CHR(15),;                                //[4] 17cpi
               CHR(18),;                                //[5] 10cpi
               CHR(15),;                                //[6] 17cpi
               CHR(18),;                                //[7] 10cpi
               "",;                                     //[8] Quick Gotic 12
               "",;                                     //[9] Courier 10
               CHR(27)+CHR(91)+CHR(83)+CHR(2)+CHR(0);
                  +CHR(3)+CHR(96),;                     //[10] oberer Rand
               CHR(27) + "E",;                          //[11] Fett ein
               CHR(27) + "F",;                          //[12] Fett aus
               "" }                                     //[13] INIT

    OTHERWISE
    aPP:={ {|n| CHR(27) + CHR(108) + CHR(n+1) },;   //[1] linker Rand
           CHR(27) + CHR(120) + CHR(0),;            //[2] Draft
           CHR(27) + CHR(120) + CHR(1),;            //[3] Letter
           CHR(27) + CHR(103),;                     //[4] 15cpi
           CHR(27) + CHR(80),;                      //[5] 10cpi
           CHR(15),;                                //[6] small on
           CHR(18),;                                //[7] small off
           CHR(27) + CHR(107) + CHR(52),;           //[8] Quick Gotic 12
           CHR(27) + CHR(107) + CHR(0),;            //[9] Courier 10
           "",;                                     //[10] oberer Rand
           CHR(27) + CHR(69),;                      //[11] Fett ein
           CHR(27) + CHR(70),;                      //[12] Fett aus
           CHR(27) + CHR(64) }                      //[13] INIT

END

SETCOLOR(farbe1)
CLS

@ 0,AppMaxCol-16 SAY PADC(programname + " " + programversion, 16);
                 COLOR IF("\TEST\"$UPPER(si_path) .OR. "X:\"$UPPER(si_path), "r+/w+", farbe5 )

RETURN


*************************
FUNC ntow2(nValue, nChar)
//Formatierung fr Whrung mit Soll bzw. Haben
RETURN ntow( ABS(nValue), nChar) + IF(nValue<0, " S", " H")


**************
FUNC is_slid()
//ermittelt ob Stckliste in GETACTIVE() existiert
LOCAL lRet:=.f., oGet:=GETACTIVE(), _slid:=0

_slid := oGet:buffer
IF VAL(_slid)==0
    RETURN .t.
END
lRet := is_sl(_slid)
IF !lRet
    ALERT("Stckliste existiert nicht")
END
RETURN lRet


**************
FUNC is_sl(_sn)
//ermittelt ob Stckliste existiert
LOCAL owa:=SELECT(),;
      lslv:=SELECT("sl_verz")==0,;
      nRec:=0, nRecLager:=lager->(RECNO()), cOrd:="", lRet:=.f.

IF lslv
    slv_open()
ELSE
    nRec:=sl_verz->(RECNO())
    cOrd:=sl_verz->(ORDSETFOCUS("sl_id"))
END
lRet := sl_verz->(DBSEEK(_sn))
IF lslv
    CLOSE sl_verz
ELSE
    sl_verz->(ORDSETFOCUS(cOrd))
    sl_verz->(DBGOTO(nRec))
END
lager->(DBGOTO(nRecLager))  // Falls durch Relation gendert
SELECT (owa)
RETURN lRet



*************
FUNC is_fbk()
//ermittelt, ob FBK existiert
LOCAL nRec:=0, nWa:=0, lRet:=.f., lSel:=.f., oGet:=GETACTIVE()

IF VAL(oGet:buffer)==0
    RETURN .t.
END

lSel:=SELECT("fbk")>0
IF lSel
    nRec:=fbk->(RECNO())
ELSE
    nWa:=SELECT()
    fbk_open()
    SELECT (nWa)
END
cOrd:=fbk->(ORDSETFOCUS("fbknr"))
lRet:=fbk->(DBSEEK( VAL(oGet:buffer) ))
IF lSel
    fbk->(ORDSETFOCUS(cOrd))
    fbk->(DBGOTO(nRec))
ELSE
    CLOSE fbk
END
IF !lRet
    ALERT("FBK-Nr. existiert nicht")
END
RETURN lRet


**************
FUNC is_user()
//ermittelt, ob User-Login existiert
LOCAL nWa:=0, lRet:=.f., oGet:=GETACTIVE()

IF EMPTY(oGet:buffer)
    RETURN .t.
END

nWa:=SELECT()
user_open()
lRet:=user->(DBSEEK( UPPERG( oGet:buffer ) ))
CLOSE user
SELECT (nWa)
IF !lRet
    ALERT("User-Login nicht angelegt")
END
RETURN lRet


**************
PROC pp_disp()
//Prfpolynom zeigen
LOCAL wi:=swopen(10,25,14,54, "Prfpolynom"), sn:=0

DISPBEGIN()
SETCURSOR(1)
@ 1,1 SAY "Sachnummer:" GET sn PICTURE "999999"
DISPEND()
READ
IF UPDATED()
#ifdef __XPP__
    @ 1,13 SAY STRTRAN(STR(pruef_pol(sn),8,1), ",", ".")
#else
    @ 1,13 SAY STR(pruef_pol(sn),8,1)
#endif
    INKEY(0)
END
swclose(wi)
RETURN


****************
PROC pos_renum()
//Feld "Pos" neu nummerieren
//fr ang_tabEd(), ls_tabEd(), re_tabEd()

LOCAL nWa:=SELECT(), nRec:=RECNO(), lLock:=.t., nPos:=1
DBGOTOP()

//alle Stze sperren
DBEVAL( {|| lLock:=DBRLOCK( RECNO() )},,;
        {|| lLock } )            // while

IF lLock
    //neu nummerieren
    DBEVAL({|| (nWa)->pos:=nPos++ })
    DBCOMMIT()
ELSE
    ALERT(ne1)
END

//Stze freigeben
DBUNLOCK()
DBGOTO(nRec)
RETURN


*****************************
PROC dlgEdInfo(cInfo, lRecht)
// Notiz (nWA)->info aus Dialog bearbeiten
LOCAL nWA:=SELECT()
(nWA)->(notiz(, lRecht))
cInfo:=IF(LEN(info) > 0,"J","N")
refr_gl()
RETURN


**********
FUNC f7(n)
//Formatierung fr numerische Werte
LOCAL cStr:=LTRIM( STR(n,10,3) ), i:=0
WHILE i<3
    IF RIGHT(cStr, 1) == "0"
        cStr:=SUBSTR(cStr, 1, LEN(cStr)-1)
    END
    i++
END
IF RIGHT(cStr, 1) == "."
    cStr:=SUBSTR(cStr, 1, LEN(cStr)-1)
END
IF LEN(cStr) >7
    cStr:="*******"
END
RETURN PADL(cStr,7)


**********
FUNC f6(n)
//Formatierung fr numerische Werte
LOCAL cStr:=LTRIM( STR(n,10,3) ), i:=0
WHILE i<3
    IF RIGHT(cStr, 1) == "0"
        cStr:=SUBSTR(cStr, 1, LEN(cStr)-1)
    END
    i++
END
IF RIGHT(cStr, 1) == "."
    cStr:=SUBSTR(cStr, 1, LEN(cStr)-1)
END
IF LEN(cStr) >6
    cStr:="******"
END
RETURN PADL(cStr,6)


**********
FUNC f5(n)
//Formatierung fr numerische Werte
LOCAL cStr:=LTRIM( STR(n,10,3) ), i:=0
WHILE i<3
    IF RIGHT(cStr, 1) == "0"
        cStr:=SUBSTR(cStr, 1, LEN(cStr)-1)
    END
    i++
END
IF RIGHT(cStr, 1) == "."
    cStr:=SUBSTR(cStr, 1, LEN(cStr)-1)
END
IF LEN(cStr) >5
    cStr:="*****"
END
RETURN PADL(cStr,5)


**************
FUNC test_sn(nLang, nZTrow, nZTcol)
// Testen, ob Sachnummer existiert,
// Felder fllen: bez, einh, ep
// fr angebot.prg, auftrag.prg, ls.prg, fbk.prg, fibu.prg (ar)

LOCAL go:=GETACTIVE(), nRecLa:=0, cOrdLa:="", nWA:=SELECT(), lRet:=.f.

IF go:changed .AND. VAL(go:buffer)>0
    nRecLa:=lager->(RECNO())
    cOrdLa:=lager->(ORDSETFOCUS("sn"))
    IF lager->(DBSEEK(go:buffer))
        (nWA)->sn:=go:buffer
        fill_mask(nLang, nZTrow, nZTcol)
        lRet:=.t.
    ELSE
        ALERT("Sachnummer ungltig: " + go:buffer)
        go:undo()
    END
    lager->(ORDSETFOCUS(cOrdLa))
    lager->(DBGOTO(nRecLa))
ELSE
    lRet:=.t.
END
RETURN lRet


***************
FUNC test_bez(nLang, nZTrow, nZTcol)
// Artikelsuche starten, falls Feld "bez" leer
// Felder fllen: bez, einh, ep
// fr angebot.prg, auftrag.prg, ls.prg, fbk.prg, fibu.prg (ar)

LOCAL go:=GETACTIVE(), lRet:=.f., _sn:="", nWA:=SELECT()
IF EMPTY(go:buffer)
    _sn:=nsuch()
#ifdef __XPP__
    SETCURSOR(1)
#endif
    IF !EMPTY(_sn)
        (nWA)->sn := _sn
        fill_mask(nLang, nZTrow, nZTcol)
        lRet:=.t.
    END
ELSE
    lRet:=.t.
END
RETURN lRet


****************
FUNC fill_mask(nLang, nZTrow, nZTcol)
// Felder fllen, falls sn existiert
// fr angebot.prg, auftrag.prg, ls.prg

LOCAL nRecLa:=0, cOrdLa:=0, nWA:=SELECT(), cSN:=sn, cBez:=""

nRecLa:=lager->(RECNO())
cOrdLa:=lager->(ORDSETFOCUS("sn"))

IF lager->(DBSEEK(cSN))

    IF nLang==2  // englische Bezeichnung aus Preisliste
        cBez := PlBez(cSN)
    END
    (nWA)->bez := IIF(EMPTY(cBez), lager->bezeichn, cBez)
    IF (nWA)->(FIELDNUM("zt")) > 0 .AND. EMPTY((nWA)->zt)
        (nWA)->zt := PlZT(cSN, nLang)
        IF !EMPTY(nZTrow) .AND. !EMPTY(nZTcol)
            disp_zt((nWA)->zt, nZTrow, nZTcol)
        END
    END

    // falls Feld "einh" existiert
    IF (nWA)->(FIELDNUM("einh")) > 0
        (nWA)->einh := Einh2Unit(lager->einheit, nLang)
    END

    // falls Feld "ep" existiert
    IF (nWA)->(FIELDNUM("ep")) > 0
        (nWA)->ep   := lager->vp
    END
END

lager->(ORDSETFOCUS(cOrdLa))
lager->(DBGOTO(nRecLa))

refr_gl()       //refresh getlist (dislay all)
RETURN .t.


****************
PROC disp_zt(zt, nZTrow, nZTcol, nLM)
// Zusatztext (Memofeld) anzeigen
LOCAL   z2:="", z3:="", z4:=""

IF nLM==NIL
    nLM := LENMEMO
END
@ nZTrow,nZTcol   SAY MEMOLINE(zt,nLM,1) COLOR farbe4
@ nZTrow+1,nZTcol SAY IF(EMPTY(z2:=MEMOLINE(zt,nLM,2)),;
                         SPACE(nLM), z2) COLOR farbe4
@ nZTrow+2,nZTcol SAY IF(EMPTY(z3:=MEMOLINE(zt,nLM,3)),;
                         SPACE(nLM), z3) COLOR farbe4
@ nZTrow+3,nZTcol SAY IF(EMPTY(z4:=MEMOLINE(zt,nLM,4)),;
                         SPACE(nLM), z4) COLOR farbe4
RETURN


**************
FUNC Einh2Unit(cEinheit, nLang)
// bersetzt cEinheit ins Englische wontig

LOCAL nPos := 0,;
      aD := {"St", "St.","Tag","Wo", "Wo."},;
      aE := {"pcs","pcs","day","wk.","wk."}

IF nLang = 2
    nPos := ASCAN(aD, cEinheit)
    IF nPos > 0
        cEinheit := aE[nPos]
    END
END
RETURN cEinheit



**************
FUNC testanr()
//testen, ob anr existiert
LOCAL wi:={}, cOrd:="", go:=GETACTIVE(),;
      owa:=SELECT(), lAuf:=(SELECT("auf")==0), lRet:=.t.

IF go:changed
    IF lAuf
        auf_open()
    END
    cOrd:=auf->(ORDSETFOCUS("anr"))
    IF !auf->(DBSEEK(VAL(go:buffer)))
        ALERT("Auftrags-Nummer ungltig: " + go:buffer)
        go:undo()
        lRet:=.f.
    END
    IF lAuf
        CLOSE auf
    ELSE
        auf->(ORDSETFOCUS(cOrd))
    END
    SELECT (owa)
END
RETURN lRet


*****************
FUNC testid(nGet)
//Testen, ob sl_id existiert
//Feld "bez" fllen
LOCAL nWa:=SELECT(), go:=GETACTIVE(), cOrd:="", lRet:=.t.,;
      lSlv:=SELECT("sl_verz")==0
IF go:changed .AND. VAL(go:buffer)>0
    lRet:=.f.
    IF lSlv
        slv_open()
    END
    cOrd:=sl_verz->(ORDSETFOCUS("sl_id"))
    lRet:=sl_verz->(DBSEEK( VAL(go:buffer) ))
    IF !lRet
        ALERT("SL-ID ungltig: " + go:buffer)
        go:undo()
    ELSE
        IF lager->(DBSEEK( VAL(go:buffer) ))
            go:=getlist[nGet]
            go:varput(lager->bezeichn)
            KEYBOARD(CHR(K_RETURN))
        END
    END
    sl_verz->(ORDSETFOCUS(cOrd))
    IF lSlv
        CLOSE sl_verz
    END
END
SELECT(nWa)
RETURN lRet


****************************************************
PROC tbs_edit(cText, aBloInf, cTitel, lEd, nTabCols)

//Editor fr Textbausteine in Formularen
//neu nTabCols=Memofeld-Breite (in Zeichen)

LOCAL ldflag:=.t., lMore:=.t.,;
      wi:=swopen(1,0,AppMaxRow-1,79, cTitel),;
      diff:=0, i:=0, imax:=0, z:=0, xp:=0, pos:=0, nKey:=0, mark:=0,;
      aUmbr:={}

WHILE i<10
    AADD(aUmbr, MAXLINES + i*(MAXLINES+EXTRALINES-HDRLINES))
    i++
END

SETCOLOR(farbe1)
SETCURSOR(1)
SETPOS(1,0)

//Blockgrenzen bestimmen (von Zeile... bis Zeile...)
//Formular bilden
i:=0
AEVAL(aBloInf, {|x| fillBloInf(x, @i, @cText, nTabCols) })

//Hauptschleife Editor
i:=1
WHILE lMore
    IF ldflag
        DISPBEGIN()
        z:=1            //pos:=i-1+z
        xp:=ROW()       //alte Cursorposion (Zeile)
        SETCURSOR(0)
        SETPOS(0,1)     //fr ROW()!
        WHILE ROW()<MAXROW()
            pos:=i-1+z

            //Zeichen zur Anzeige des Seitenumbruch setzen:
            @ ROW()+1, 0 SAY IF( ASCAN(aUmbr, pos) > 0, ">", " ")

            mark:=0
            AEVAL(aBloInf,;
             {|x| mark+=IF(x[1] .AND. pos>x[2] .AND. pos<=x[3],1,0)})
            @ ROW(),1 SAY MEMOLINE(cText, nTabCols, pos);
                        COLOR IF(mark==0, farbe1, farbe2)
            z++
        END
        SETCURSOR(1)
        SETPOS(xp,1)
        DISPEND()
        ldflag:=.f.
    END
    nKey:=INKEY(0)
    DO CASE
        CASE nKey==K_ESC
            lMore:=.f.
        CASE nKey==K_UP
            IF ROW() > 1
                SETPOS(ROW()-1, COL())
            ELSE
                IF i>1
                    i--
                    ldflag:=.t.
                END
            END
        CASE nKey==K_DOWN
            IF ROW() < MAXROW()
                SETPOS(ROW()+1, COL())
            ELSE
                IF i < MLCOUNT(cText, nTabCols)-MAXROW()+1
                    i++
                    ldflag:=.t.
                END
            END
        CASE nKey==K_PGUP
            i-=MAXROW()+1
            IF i<1
                i:=1
            END
            ldflag:=.t.
        CASE nKey==K_PGDN
            i+=MAXROW()-1
            IF i > (imax:=MLCOUNT(cText, nTabCols)-MAXROW()+1)
                i:=imax
            END
            ldflag:=.t.
        CASE nKey==K_CTRL_PGUP
            i:=1
            SETPOS(1,COL())
            ldflag:=.t.
        CASE nKey==K_CTRL_PGDN
            i:=MLCOUNT(cText, nTabCols)-MAXROW()+1
            SETPOS(MAXROW(),COL())
            ldflag:=.t.
        CASE nKey==K_RETURN .AND. lEd
            pos:=i+ROW()-1
            diff:=0
            AEVAL(aBloInf, {|x| diff+=myMemoEdit(x,pos,@cText, nTabCols) })
            IF diff>0
                //Text neu bilden
                cText:=""
                diff:=0
                AEVAL(aBloInf, {|x| fillBloInf(x, @diff, @cText, nTabCols) })
                ldflag:=.t.
            END
        END
END
swclose(wi)
RETURN


************************************
PROC fillBloInf(x,n,cText, nTabCols)
//zu tbs_edit()
//Blockgrenzen eintragen, Blcke an cText anfgen
x[2] := n
IF RIGHT(x[4],2)!=cr    //EMPTY(x[4])
    x[4]+=cr
END
n+=MLCOUNT(x[4], nTabCols)
x[3] := n
cText+=x[4]
RETURN


****************************************
FUNC myMemoEdit(x, pos, cText, nTabCols)
//zu tbs_edit()
//Textbaustein editieren
LOCAL co:=SETCOLOR("GR+/BG"), x1:=x2:=xd:=n:=0
IF x[1] .AND. pos>x[2] .AND. pos<=x[3]
    READINSERT(.t.)
    x1:=ROW()-pos+x[2]+1            //Anfangszeile
    x1:=IF(x1 < 1, 1, x1)           //falls 1. Zeile auerhalb
    x2:=x1+x[3]-x[2]-1              //Endzeile
    x2:=IF( x2 < x1+2, x1+2, x2)    //falls weniger als 3 Zeilen

    //falls letzte Zeile auerhalb
    WHILE (xd:=MAXROW()-x2) < 0 .AND. x1 > 1
        x1 -=1
        x2 -=1
    END

    //Bearbeiten
    x[4]:=MEMOEDIT(x[4], x1, 1, x2, 1 + nTabCols - 1, .t., "m_udf", nTabCols)

    READINSERT(.f.)
    n:=1
END
SETCOLOR(co)
RETURN n


************************
PROC myErrorH(oerr, oeb)
//ERROR-Ausgabe in Fenster 0 umlenken
wselect(0)
EVAL(oeb, oerr)
RETURN


**************
FUNC zr(lExpr)
//Zugriffsrechte prfen
IF !lExpr
    ALERT("Kein Zugriffsrecht fr diese Funktion")
END
RETURN lExpr


***************
PROC dordfilt()
LOCAL cFilt:=DBFILTER(), cOrd:=ORDSETFOCUS()
@ 0,1 SAY PADR("Order: " + IF(EMPTY(cOrd), "-", cOrd);
            + ", Filter: " + IF(EMPTY(cFilt), "-", cFilt),50)
RETURN


************
PROC dfilt()
LOCAL cFilt:=DBFILTER()
@ 0,1 SAY PADR("Filter: " + IF(EMPTY(cFilt), "-", cFilt),50)
RETURN


*****************
FUNC sup_delrec()
//Satz lschen (nur mit Supervisor-Rechten)
LOCAl nRec:=ORDKEYNO(), lRet:=.f.

//IF netuser="SUP" .AND. ALERT("Satz lschen?", jn)==1 .AND. myRLock()
IF zr(lSUP) .AND. ALERT("Satz lschen?", jn)==1 .AND. myRLock()
    IF LOWER(ALIAS()) == "lager"
        artlog("Gelscht")
    END
    DBDELETE()
    DBUNLOCK()
    IF nRec<=LASTREC()
        ORDKEYGOTO(nRec)
    END
    lRet := .t.
END
RETURN lRet


***************
PROC setorder()
//Reihenfolge bestimmen
LOCAL nRec:=RECNO(), nNr:=1, cOrd:="", aOrd:={}, wi:={}
WHILE !EMPTY(cOrd:=ordname(nNr++))
    AADD(aOrd, cOrd)
END
wi:=swopen(9,25,16,54,"Reihenfolge setzen")
nNr:=ACHOICE(1, 0, MAXROW(), MAXCOL(), aOrd,,, ORDNUMBER( ORDSETFOCUS() ))
swclose(wi)
IF nNr>0
    ORDSETFOCUS(nNr)
    DBGOTO(nRec)
    IF BOF() .OR. EOF()
        DBGOBOTTOM()
    END
END
RETURN


***********************
FUNC lifu(cLief, n_lnr)
//Zuweisung Lief/Ku mit Suchfunktion
LOCAL aft:="", aFeld:={}, aFeld2:={}, wi:={}, go:=GETACTIVE()
IF go:changed
    cLief:=ALLTRIM(cLief)
    n_lnr:=0
    IF CharOnly("0123456789", cLief) == cLief
        IF lk->(DBSEEK(VAL(cLief)))
            go:varPut(lk->firma1)
            n_lnr:=VAL(cLief)
        END
    ELSE
        wi:=meldung()
        cLief:=UPPERG(cLief)
        lk->(DBEVAL( {|| AADD(aFeld, {STR(lnr,4,0), firma1, firma2, ort, fom, partner} ) },;
            {|| cLief $ UPPERG(lk->firma1) .OR. cLief $ UPPERG(lk->firma2) } ))
        del_meld(wi)
        IF LEN(aFeld)=1
            go:varPut(aFeld[1,2])
            n_lnr:=VAL(aFeld[1,1])
            lk->(DBSEEK(n_lnr))
        ELSEIF LEN(aFeld)>1
            AEVAL(aFeld,{|x| AADD(aFeld2, x[1] + "  " +;
                                          PADR(TRIM(x[2])+" "+x[3], AppMaxCol - 53) + "  " +;
                                          PADR(LTRIM(x[5]+" "+x[6]), 20) +;
                                          PADR(x[4], 20))})
            wi:=swopen(2,0,AppMaxRow,AppMaxCol,"Auswahl")
            aft:=futa({})
            wformat(1,0,0,0)
            w:=ACHOICE(0,0,MAXROW(),MAXCOL(),aFeld2)
            swclose(wi)
            restfuta(aft)
            SETCURSOR(1)
            IF w>0
                go:varPut(aFeld[w,2])
                n_lnr:=VAL(aFeld[w,1])
                lk->(DBSEEK(n_lnr))
            ELSE
                go:setFocus()
            END
        END
    END
#ifdef FIBU
    IF n_lnr==0 .AND. ALERT("Neuer Kunde bzw. Lieferant?", jn)==1
        IF lk->(lk_new())
            go:varPut(lk->firma1)
            n_lnr:=lk->lnr
        END
    END
#endif
END
RETURN (n_lnr>0)


*****************
FUNC lifu_haendler(cLief, n_lnr)
LOCAL nRec:=lk->(RECNO()), n_lnr_local:=0, lRet:=.f.

lk->(DBSETFILTER({|| haendler}, "haendler"))
lRet := lifu(cLief, @n_lnr_local)
lk->(DBCLEARFILTER())
lk->(DBGOTO(nRec))
n_lnr := n_lnr_local
RETURN lRet .OR. EMPTY(cLief)   // darf leer sein


*************************
FUNC lifu_lang(cKunde, n_lnr, cLang)
LOCAL n_lnr_alt:=n_lnr, lOK:=lifu(cKunde, @n_lnr)

IF lOK .AND. n_lnr <> n_lnr_alt
    cLang := lk->sprache
    refr_gl()
END

RETURN lOK


*************************
PROC set_ar_lang_defaults(cLang)
IF cLang=="E"
    ar->lang := 2
    ar->mwst := 0
    ar->ks   := 4125
ELSE
    ar->lang := 1
    ar->mwst := D_MWST
    ar->ks   := 4400
END
RETURN


*************************
PROC set_ar_lang_ftb(cLang)
IF cLang=="E" .AND. EMPTY(ar->ftb) .AND. ar->sh=="H"  //falls Rechnung
    ar->ftb := cr +;
               tk[47,ar->lang] + cr +;
               IF(ar->frist==0,;
                  "Payment:  Cash in Advance or MasterCard",;
                  "Payable within " +;
                    IF(ar->skonto>0,;
                       STR(ar->sfrist,2) + " days with " +;
                         STR(ar->skonto,2) + " % discount" + cr +;
                         "or within ",;
                       "") +;
                    LTRIM(STR(ar->frist,3)) + " days strictly net.")
END
RETURN


*************************
PROC edinfo(cText, lEdit)
LOCAL aArt:={}
IF myRLock()
    IF LOWER(ALIAS()) == "lager"
        lager->(GetRec(aArt))   // Feldinhalte zum spteren Vergleich
        notiz(@cText, @lEdit)
        artlog(lager->(ChangedFields(aArt)))  // aIgnore unntig da nur INFO mglich
    ELSE
        notiz(@cText, @lEdit)
    END
    DBCOMMIT()
    DBUNLOCK()
END
RETURN

************************
PROC notiz(cText, lEdit)
//Memofeld bearbeiten
LOCAL aft:="", wi:={},;
      okbl:=SETKEY(K_ALT_N, {|| NIL }),;
      bPGUP:=SETKEY(K_PGUP, {|| NIL }),;
      bPGDN:=SETKEY(K_PGDN, {|| NIL }),;
      nCursor:=SETCURSOR()

aft:=futa( IF(lEdit==.t., {"F10 Save"}, {}) )
wi:=swopen(2,3,22,76,IF(EMPTY(cText), "Notiz" , cText), farbe3)
SETCOLOR(farbe2)
SETCURSOR(1)
READINSERT(.t.)
REPLACE info WITH MEMOEDIT(info,1,0,MAXROW(),MAXCOL(), lEdit,"m_udf", MAXCOL()+1)
swclose(wi)
restfuta(aft)
SETKEY(K_ALT_N, okbl)
SETKEY(K_PGUP, bPGUP)
SETKEY(K_PGDN, bPGDN)
SETCURSOR(nCursor)
RETURN


*****************
FUNC m_udf(m,z,s)
// Funktion fr memoedit()
LOCAL nRet:=0, nWahl:=0, nKey:=LASTKEY()
#ifdef __XPP__
STATIC lEdited   := .F.,;
       aEditKeys := {K_RETURN, K_DEL, K_BS, K_TAB, K_CTRL_B, K_CTRL_T, K_CTRL_Y}
IF m==ME_INIT
    lEdited := .F.
ELSE
    IF (nKey>=K_SPACE .AND. nKey<=255) .OR. AScan(aEditKeys,nKey)>0
        lEdited := .T.
    END
    IF lEdited
        m := ME_UNKEYX
    END
END
#endif
IF m==ME_UNKEYX
    IF nKey==K_F10
        nRet:=K_CTRL_W
    ELSEIF nKey==K_ESC
        nWahl:=ALERT("Editor schlieen;nderungen",{"bernehmen","verwerfen"})
        IF nWahl==1
            nRet:=K_CTRL_W
        ELSEIF nWahl==2
            nRet:=K_ESC
        ELSE
            nRet:=ME_IGNORE
        END
    END
END
RETURN nRet


***********************
FUNC newnumber(nLastNr)
//fortlaufende 7-stellige Nummer vergeben,
//vorangestellte Jahresangabe (99 fr 1999, 100 fr 2000 usw.)
LOCAL nNewYear:=10000 * (YEAR(date())-1900) + 1, nNewNr:=0
IF nLastNr < nNewYear
    nNewNr := nNewYear
ELSE
    nNewNr := nLastNr + 1
END
RETURN nNewNr



****************************************************************
// Funktionen fr Fenster

***************************
FUNC swopen(a,b,c,d,txt,co)
//Fenster ffnen
LOCAL aFeld:={}, nSC:=SETCURSOR()
AADD(aFeld, WSELECT())
AADD(aFeld, WOPEN(a,b,c,d))
#ifdef __XPP__
AADD(aFeld, nSC)
if co==NIL
    co := farbe1
end
#endif
SETCOLOR(co)
WBOX()
#ifdef __XPP__
WFORMAT(-1,0,-1,0)
IF txt!=NIL
    WSetTitle(0, 2, " " + txt + " ")
END
SETCURSOR(1)
#else
WFORMAT(0,1,0,1)
IF txt!=NIL
    @ -1,1 SAY " " + txt + " "
END
#endif
RETURN aFeld


******************
PROC swclose(aFeld)
//Fenster schlieen
wselect(aFeld[2])
wclose()
wselect(aFeld[1])
#ifdef __XPP__
SETCURSOR(aFeld[3])
#endif
RETURN


************
FUNC futa(f, w)
//Zeile mit Funktionstastenbelegung
LOCAL x:=1, nSC:=SETCURSOR(), ws:=wselect(), aft:={}
IF w==NIL
    w := 8
END
wselect(0)
DISPBEGIN()
aft := {SAVESCREEN(AppMaxRow,0,AppMaxRow,AppMaxCol), nSC}
#ifdef __XPP__
SETCOLOR(farbe1)
#endif
@ AppMaxRow,0 SAY SPACE(AppMaxCol+1)
SETPOS(AppMaxRow,0)
WHILE x <= LEN(f)
    @ AppMaxRow, COL()+1 SAY PADR(f[x], w) COLOR farbe2
    x++
END
DISPEND()
wselect(ws)
#ifdef __XPP__
SETCOLOR(farbe1)
#endif
RETURN aft


****************
PROC restfuta(s)
//Zeile mit Funktionstastenbelegung wiederherstellen
LOCAL ws:=wselect()
wselect(0)
RESTSCREEN(AppMaxRow,0,AppMaxRow,AppMaxCol,s[1])
wselect(ws)
SETCURSOR(s[2])
RETURN


***********
FUNC upn(s)
//neue Infozeile ausgeben, alte zurckgeben
LOCAL nSC:=SETCURSOR(), ws:=wselect(), ret:=""
wselect(0)
ret:=ALLTRIM(CHARODD(SAVESCREEN(0,1,0,AppMaxCol-16)))
@ 0,1 SAY " " + PADR(IF(s=NIL, "", s), AppMaxCol-18) COLOR farbe2
wselect(ws)
SETCURSOR(nSC)
RETURN ret


************
FUNC wton(x)
// Whrungsformat in num. Format
LOCAL kl:=AT(",", x), kr:=RAT(",", x),;
      pl:=AT(".", x), pr:=RAT(".", x),;
      l:=len(x)
IF kl>0
    IF kl=kr .AND. kr > l-3 .AND. IF(pr>0, kr=pr+4, .t.)
        x:=STRTRAN(x, ".", "")
        x:=STRTRAN(x, ",", ".")
    ELSE
        ALERT("Format ungltig!")
        x:=""
    END
ELSE
    IF pl>0 .AND. (pr<>pl .OR. pr < l-2)
        ALERT("Format ungltig!")
        x:=""
    END
END
RETURN VAL(x)


**************
FUNC ntow(n,l,nLang)
// numerisches in Whrungsformat
LOCAL x:="", pos:=0, nvz:=(n<0), tz:="."

IF nvz
    n=n*(-1)
END
IF l=NIL
    l:=10
END
IF nLang=NIL
    nLang:=1    // deutsch
ELSEIF nLang=2  // englisch
    tz:=","     // "tausend"-Trennzeichen
END
x:=STR(n, l, 2)
pos:=AT(".", x)
IF nLang=1
    x:=STRTRAN(x, ".", "," )
END
WHILE pos>3 .AND. SUBSTR(x, pos-4, 1) != " "
    x:=STUFF(x, pos-3, 0, tz)
    pos:=AT(tz, x)
END
x:=LTRIM(x)
IF nvz
    x:="-"+x
END
IF LEN(x) > l
    x:=REPLICATE("***", l)
END
RETURN PADL(x, l)


**************
FUNC ntow12(n)
RETURN IF(n=0, SPACE(12), ntow(n,12))


**************
FUNC ntos(nValue, nLang, nLength, nDecimals)
LOCAL x:=STR(nValue, nLength, nDecimals)
IF nLang = 1
    x := STRTRAN(x, ".", "," )
END
RETURN x


***************
FUNC meldung(s)
// Meldungsfenster AUF
LOCAL c:=SETCURSOR(0), wi:=wselect(), f:=SETCOLOR("w+/r")
s:=IF(s=NIL, "Bitte warten!", s)
wopen(10, 38-LEN(s)/2, 14, 42+LEN(s)/2)
#ifdef __XPP__
SETCOLOR("w+/r")
#endif
wbox()
cls
@ 1,1 SAY s
RETURN {wi,c,f}


****************
PROC del_meld(f)
// Meldungsfenster ZU
wclose()
wselect(f[1])
SETCURSOR(f[2])
SETCOLOR(f[3])
RETURN


***********************************
PROC help(prg_name, zeile, var_ein)
// kontextbezogene Hilfe aufrufen, ggf. anlegen

LOCAL nWA:=SELECT(), wi:={}, yn:="J", getlist:={}, aFuKey:=rstfk(), cText:=""

SET KEY K_F1 TO     // Hilfetaste F1 ausschalten
READINSERT(.t.)
IF help_open()

    IF help->(DBSEEK(begr:=prg_name+" "+PROCNAME(3)))
        IF help->show
            wi:=swopen(2,5,22,74,"Hilfe: " + TRIM(help->thema), farbe3)
            SETCOLOR(farbe2)
            SETCURSOR(1)
            cText:=MEMOEDIT(help->text,1,0,MAXROW(),MAXCOL(), lHelp, "m_udf")
            swclose(wi)
        END
        IF lHelp .AND. myRLock()    // Alias: help
            help->text := cText
            DBCOMMIT()
            DBUNLOCK()
        END

    ELSE
        IF lHelp
            wi:=swopen(2,5,22,74,"Hilfe", farbe3)
            DISPBEGIN()
            SETCOLOR(farbe2)
            SETCURSOR(1)
            @ 1,0 SAY "Prozedur: " + prg_name + ", " + procname(3)
            @ 2,0 SAY "Variable: " + var_ein
            @ 4,0 SAY "Neues Hilfsthema anlegen (J/N):";
                  GET yn PICTURE "!" VALID yn $ "JN"
            DISPEND()
            READ
            IF yn="J" .AND. help->(myAppend())
                DISPBEGIN()
                @ 6,0 SAY "Thema:" GET help->thema
                DISPEND()
                READ
                IF UPDATED()
                    help->ix := begr
                    help->show := .t.
                    help->text := MEMOEDIT(help->text,1,0,MAXROW(),MAXCOL(), .t., "m_udf")
                ELSE
                    help->ix := ""
                    help->(DBDELETE())
                END
            END
            swclose(wi)
        END
    END
    CLOSE help
END
SELECT (nWA)
SET KEY K_F1 TO help()      // Hilfetaste wieder einschalten
setfk(aFuKey)
RETURN


****************
FUNC help_open()
#ifdef USE_POSTGRES
LOCAL cTable:="help"
USE (cTable) ALIAS help VIA (cDBECDX) SHARED NEW
_OrdListAdd(cTable)
RETURN .t.
#else
// Hilfedatei ffnen, ggf. anlegen
LOCAL lRet:=.f., cFile:=si_path + "\help"
IF !FILE(cFile+".dbf")
    ALERT("Datei " + cFile + ".dbf konnte nicht geffnet werden!;" +;
          "Bitte Systemadministrator informieren (vermutlich Netzwerkproblem)!")
    Quit_App()
/*
    DBCREATE(cFile, {   {"ix","C",20,0},;
                        {"thema","C",20,0},;
                        {"text","M",10,0},;
                        {"show","L",1,0}     },;
                        cDBECDX)
*/
END
USE (cFile) ALIAS help SHARED NEW VIA (cDBECDX)
IF lRet:=NETERR()
    ALERT(ne4 + cFile)
ELSE
    IF FILE (cFile+".cdx")
        _OrdListAdd(cFile)
    ELSE
        INDEX ON ix TAG ix TO (cFile + ".cdx")
    END
END
RETURN !lRet
#endif





****************************************************************
*   allgemeine Filterfunktion fr Browseobjekte
*
*

****************
PROC fb_filter()
// allg. Filter
LOCAL i:=zei:=nZeilen:=1, spa:=2, wi:=swopen(2,3,22,76,"Filter setzen"),;
      fi:=PADR(DBFILTER(), 100), fs:=DBSTRUCT(), bErr:=ERRORBLOCK()

DISPBEGIN()
nZeilen := INT((LEN(fs)+4)/5)
DISPBOX(0, 0, nZeilen+1, MAXCOL())
WHILE i<= LEN(fs)
    @ zei++, spa SAY fs[i,2] + " " + LOWER(fs[i++,1])
    IF zei > nZeilen
        zei := 1
        spa += 14
    END
END
SETCURSOR(1)
@ nZeilen+3,1 SAY "Bedingung:" GET fi PICTURE "@s50" VALID fb_filter_valid(fi)
DISPEND()
READ
fi:=TRIM(fi)
swclose(wi)
IF "&"$fi
    ALERT("Zeichen unzulssig: &")
ELSE
#ifndef __XPP__
    ERRORBLOCK({|oError| filt_err(oError)})
#endif
    BEGIN SEQUENCE
        wi:=meldung("Setze Filter")
        SET FILTER TO &fi
        DBGOTOP()
        del_meld(wi)
    RECOVER
        SET FILTER TO
        del_meld(wi)
    END SEQUENCE
#ifndef __XPP__
    ERRORBLOCK(bErr)
#endif
END
RETURN


************
FUNC fb_filter_valid(cBedingung)
STATIC aBedingungen:={}
IF "&" $ cBedingung
    RETURN .f.
END
RETURN BegHist(cBedingung, aBedingungen, .t.)


*********************
PROC filt_err(oError, cBed)
TONE(880,1)
ALERT("Filterausdruck unzulssig!;;" + cBed)
BREAK oError
RETURN


********************
PROC newfilter(cBed)
LOCAL bErr:=ERRORBLOCK({|oError| filt_err(oError, cBed)})
BEGIN SEQUENCE
    SET FILTER TO &cBed
    DBGOTOP()
RECOVER
    SET FILTER TO
END SEQUENCE
ERRORBLOCK(bErr)
RETURN


************************
PROC lnr_filter(cLnrStr, cLnrStr2)
// Filter fr Kunde/ Lieferant
LOCAL aft:=futa({}), li:=SPACE(nLenFirma1), cBed:="", n_lnr:=0, wi:={}
IF EMPTY(cLnrStr)
    cLnrStr:="lnr"
END

wi:=swopen(10,15,14,36+nLenFirma1,"Filter setzen", farbe3)
DISPBEGIN()
SETCOLOR(farbe2)
SETCURSOR(1)
@ 1,0 SAY "Kunde/ Lieferant:" GET li VALID lifu(li, @n_lnr)
DISPEND()
READ
swclose(wi)
IF n_lnr>0
    cBed := cLnrStr + "==" + STR(n_lnr)
    IF !EMPTY(cLnrStr2)
        cBed += " .OR. " + cLnrStr2 + "==" + STR(n_lnr)
    END
    SET FILTER TO &cBed
    DBGOTOP()
END
restfuta(aft)
RETURN


********************
PROC mon_filter(owa)
//Filter fr Monat
LOCAL m:=RIGHT(DTOC(date()),5),;
      wi:=swopen(10,20,14,59,"Filter setzen",farbe3)

DISPBEGIN()
SETCOLOR(farbe2)
SETCURSOR(1)
@ 1,5 SAY "Monat:" GET m PICTURE "99.99"
DISPEND()
READ
swclose(wi)
IF LASTKEY()!=K_ESC
    newFilter( "RIGHT(DTOC(rdat),5)=="+CHR(34)+m+CHR(34) )
END
RETURN


************
PROC such_filter(cFeldName, cFensterTitel, cInhaltSay, cInhalt)
// Suche (Filter) ber cFeldName im aktuellen Arbeitsbereich
LOCAL wi:={}, aft:=futa({})

IF EMPTY(cInhalt)
    IF EMPTY(cInhaltSay)
        cInhaltSay := "Inhalt:"
    END
    cInhalt := SPACE(30)
    wi := swopen(10,13,14,65,cFensterTitel, farbe3)
    DISPBEGIN()
    SETCURSOR(1)
    SETCOLOR(farbe3)
    @ 1,0 SAY cInhaltSay GET cInhalt VALID nsuch_valid(cInhalt)
    DISPEND()
    READ
    swclose(wi)
    restfuta(aft)
END
cInhalt := ALLTRIM(cInhalt)
IF !EMPTY(cInhalt)
    newfilter(Quote(UPPERG(cInhalt)) + "$UPPER(" + cFeldName + ")")
END
RETURN



****************************************************************

****************
FUNC seek_user()
//netuser suchen, vollst. Namen und Zugriffsrechte lesen
//username/ netuser (Login name) sind PUBLIC
#ifdef __XPP__
LOCAL   cFile:="w:\ads.idx", lRet:=.f., wi:={}

IF !FILE(cFile)
    ALERT("Error: Datei " + cFile + " nicht gefunden!")
ELSE
    IF !FILE("C:\sima\Test\SIMAPG\ads.ini")
        COPY FILE t:\batch\ads.ini TO C:\sima\Test\SIMAPG\ads.ini
    END
    IF !FILE("C:\sima\Test\SIMAPG\simawin.cfg")
        COPY FILE t:\batch\simawin.cfg TO C:\sima\Test\SIMAPG\simawin.cfg
    END
    IF !FILE("C:\sima\Test\SIMAPG\fibuwin.cfg")
        COPY FILE t:\batch\simawin.cfg TO C:\sima\Test\SIMAPG\fibuwin.cfg
    END
    netuser := LEFT(UPPERG(GETENV("USERNAME")), 3)
#else
LOCAL   cFile:="C:\sima\Test\SIMAPG\simauser.dat", lRet:=.f., wi:={}

IF !FILE(cFile)
    ALERT("Error: Login-Namen nicht bergeben")
ELSE
    netuser:=MEMOREAD(cFile)
    DELETE FILE (cFile)
    netuser:=SUBSTR(netuser, AT("USERNAME=", netuser) + 9, 20)
    altd()
    netuser:=UPPERG( LEFT(netuser, AT(cr, netuser)-1 ) )
#endif
    IF user_open()
        IF EOF()
            //ggf. ersten User anlegen (erhlt SUPERVISOR-Rechte!)
            DBAPPEND()
            user->benutzer:=netuser
            user->lsup:=.t.
            lsup:=.t.
            lRet:=.t.
        ELSE
            IF DBSEEK(netuser)          //User suchen
                username:=TRIM(name)    //vollen Namen zuweisen
                nrFibu:=user->nrfibu
                nrArt:=user->nrart
                nrSl:=user->nrsl
                nrMp:=user->nrmp
                nrLs:=user->nrls
                nrLk:=user->nrlk
                nrLo:=user->nrlo
                nrAng:=user->nrang
                nrAuf:=user->nrauf
                nrFA:=user->nrfa
                lHelp:=user->lhelp
                lSup:=user->lsup
                lRet:=.t.
            ELSE
                ALERT("Benutzer " + netuser + " nicht registriert")
            END
        END
        CLOSE user
    END
END
RETURN lRet


****************
FUNC usertoname(cUser)
// cUser suchen, vollst. Namen zurckliefern (PUBLIC username falls nicht gefunden)
LOCAL   owa:=SELECT(), cName:=username

IF user_open()
    IF DBSEEK(cUser)
        cName := TRIM(user->name)
    END
    CLOSE user
END
SELECT (owa)
RETURN cName


****************
FUNC user_open()
#ifdef USE_POSTGRES
LOCAL cTable:="benutzer"
USE (cTable) ALIAS user VIA (cDBECDX) SHARED NEW
_OrdListAdd(cTable)
RETURN .t.
#else
// Datei user.dbf ffnen, ggf. anlegen
LOCAL lRet:=.f., cFile:=si_path + "\benutzer"
IF !FILE(cFile + ".dbf")
    ALERT("Datei " + cFile + ".dbf konnte nicht geffnet werden!;" +;
          "Bitte Systemadministrator informieren (vermutlich Netzwerkproblem)!")
    oDBServerSession:disconnect()
    QUIT   // Sofort beenden ohne Quit_App() - weitere Schaden vermeiden!
/*
    DBCREATE(cFile, {  {"User","C",4,0},;       //Login-Name
                       {"Name","C",25,0},;      //vollst. Name
                       {"in_fibu","N",1,0},;    //Anzahl FIBU angemeldet
                       {"in_sima","N",1,0},;    //Anzahl SIMA angemeldet
                       {"nrart","N",1,0},;      //Rechte:  1 Artikel
                       {"nrsl","N",1,0},;       //2 SL/ Produkte
                       {"nrmp","N",1,0},;       //3 MP/ Bestellungen
                       {"nrfibu","N",1,0},;     //4 Fibu
                       {"nrang","N",1,0},;      //5 Angebote
                       {"nrauf","N",1,0},;      //6 Auftrge
                       {"nrfa","N",1,0},;       //7 Fertigungsauftrge
                       {"nrls","N",1,0},;       //8 Lieferschein-Rechte
                       {"nrlk","N",1,0},;       //9 Adressbuch-Rechte
                       {"nrlo","N",1,0},;       //10 Lagerort-Rechte
                       {"lhelp","L",1,0},;      //Schreibrecht fr Hilfe
                       {"lsup","L",1,0} },;     //Supervisor-Rechte
                       cDBECDX)
*/
END
USE (cFile) ALIAS user VIA (cDBECDX) SHARED NEW
IF lRet:=NETERR()
    ALERT(ne4 + cFile)
ELSE
    IF FILE(cFile + ".cdx")
        _OrdListAdd(cFile)
    ELSE
        INDEX ON benutzer TAG benutzer TO (cFile + ".cdx")
    END
//    ORDSETFOCUS("user")
//    DBGOTOP()
END
RETURN !lRet
#endif


***********************
PROC Check_Tagesbeginn(nCall)
// In sima.prg & fibu.prg aufgerufen um "einmal am Tag" Aufgaben zu erledigen:
// nCall == 1 gleich nach user_open(), bevor dat_sima bzw. dat_fibu aktualisiert
// nCall == 2 nachdem standard-DBFs (LK u.s.w.) geffnet
// Annahme: Workarea ist "user".

LOCAL nHandle:=-1, cLogFile:=LEFT(si_path,3)+"Check_Tagesbeginn.txt"
STATIC lFound:=.f.  // Bleibt .f. nur fr allererste Anmeldung am Tag, egal wer.

DO CASE
    CASE nCall == 1
        DBGOTOP()
        WHILE !lFound .AND. !EOF()
            lFound := (dat_sima=DATE() .OR. dat_fibu=DATE())
            DBSKIP(1)
        END
        DBGOTOP()
        IF !lFound
            DELETE FILE (fibu_path + "\wart.cdx")   // wegen DATE() im Index OFFEN
            WHILE !EOF()
                IF myRLock()
                    user->in_sima := 0
                    user->in_fibu := 0
                    DBCOMMIT()
                    DBUNLOCK()
                END
                DBSKIP(1)
            END
            DBGOTOP()
            IF FEXISTS(cLogFile)
                nHandle := FOPEN(cLogFile, FO_READWRITE + FO_EXCLUSIVE)
                FSEEK(nHandle, 0, FS_END)
            ELSE
                nHandle := FCREATE(cLogFile)
            END
            IF nHandle <> -1
                FWRITE(nHandle, DTOC(DATE()) + " " + TIME() + " " + programname + " " + netuser + cr)
                FCLOSE(nHandle)
            END
        END
    CASE nCall == 2
        IF !lFound
            wart_emails()   // Update-Email-Adress-Dateien erzeugen
        END
END
RETURN


****************************************************************

****************************
FUNC adr_str(_lnr, s, lEdit, nLang)
//Adresse suchen, bearbeiten und als String zurckgeben
LOCAL adr:="", aFeld:={}, wi:={}, adr_pf:="", adr_strasse:="", i:=0, nLines:=0, adr_ret:=""
IF lEdit==NIL
    lEdit:=.t.
END
IF s==NIL
    s:=.f.  //Rechnungsanschrift (PF), s:=.t. Lieferanschrift
END
IF lk->(DBSEEK(_lnr))
    adr_pf := TRIM(lk->pf) + cr + TRIM(lk->plz2) + TRIM(" " + lk->ort2) + cr
    adr_strasse := TRIM(lk->strasse) + cr + TRIM(lk->plz) + TRIM(" " + lk->ort) + cr
    adr += TRIM(lk->firma1) + cr;
        +  TRIM(lk->firma2) + cr;
        +  IF(s, IF(EMPTY(lk->strasse), adr_pf, adr_strasse),;
                 IF(EMPTY(lk->pf), adr_strasse, adr_pf) );
        +  Landname(lk->land, nLang) + cr
ELSE
    adr := REPLICATE("?" + cr,5)
END
IF lEdit
    wi:=swopen(8,15,16,nLenAdrDisplay+18,"Adresse bearbeiten",farbe3)
    SETCOLOR(farbe2)
    SETCURSOR(1)
    READINSERT(.t.)
    adr:=MEMOEDIT(adr,1,0,MAXROW(),nLenAdrDisplay,.t.,"m_udf")
    swclose(wi)
END
//Auf Umschlagsfensterbreite beschrnken
nLines := MLCOUNT(adr, nLenAdrDisplay)
FOR i := 1 TO nLines
    adr_ret += MEMOLINE(adr, nLenAdrDisplay, i) + cr
NEXT
RETURN adr_ret


**************
PROC refr_gl()
// alle Gets neu ausgeben
LOCAL x:=0
DISPBEGIN()
WHILE x < LEN(getlist)
    obj:=getlist[++x]
    obj:display()
END
DISPEND()
RETURN


*******************
PROC i_state(nFact)
//Fortschrittsanzeige (Balken)
@ 2,1 SAY PADR(REPLICATE( CHR(177), nFact*RECNO() ), 20) COLOR "w+/r"
RETURN


****************************
PROC goto_key(cStr, cNewOrd, lCharKey)
//gehe zu Satz mit Key ...
LOCAL wi:={}, cOrd:="", nRec:=RECNO(), _nr:=0, _key:=SPACE(25), lFound:=.f.

IF lCharKey == NIL
    lCharKey = .f.
END
wi:=swopen(10,20,14,59, "Gehe zu", farbe3)
DISPBEGIN()
SETCOLOR(farbe2)
SETCURSOR(1)
IF lCharKey
    @ 1,0 SAY cStr GET _key PICTURE "XXXXXXXXXXXXXXXXXXXXXXXXX"
ELSE
    @ 1,0 SAY cStr GET _nr PICTURE "9999999"
END
DISPEND()
READ
swclose(wi)

IF UPDATED()
    cOrd:=ORDSETFOCUS(cNewOrd)
    lFound := IF(lCharKey, DBSEEK(_key, .t.), DBSEEK(_nr))  // Softseek wenn Char-Key
    IF !lFound .AND. !lCharKey
        TONE(880,1)
        ALERT("Satz nicht gefunden")
        ORDSETFOCUS(cOrd)
        DBGOTO(nRec)
    ELSE
        IF cOrd!=UPPERG(cNewOrd)
            ALERT("Aktive Reihenfolge umgeschalten:;" + cNewOrd)
        END
    END
END
RETURN


****************************************************************
// versch. Netzwerkfunktionen

**************
FUNC myRLock()
// Satz sperren mit Warteschleife
LOCAL ret:=.f., i:=10, wi:={}
WHILE !(ret:=RLOCK())
    IF EMPTY(wi)
        wi:=swopen(10,25,14,54,,"W+/R")
        ? PADC("Bitte warten!",26)
    END
    IF i>0
        i--
//        INKEY(0.2) // warte 0,2 Sekunden
    ELSE
        ALERT("Satz sperren z.Z. unmglich! (" + ALIAS() + ")")
        EXIT
    END
END
IF !EMPTY(wi)
    swclose(wi)
END
RETURN ret


**************
FUNC myFLock()
// File sperren mit Warteschleife
LOCAL ret:=.f., i:=10, wi:={}
WHILE !(ret:=FLOCK())
    IF EMPTY(wi)
        wi:=swopen(10,25,14,54,,"W+/R")
        ? PADC("Bitte warten!",26)
    END
    IF i>0
        i--
//        INKEY(0.2) // warte 0,2 Sekunden
    ELSE
        ALERT("File sperren z.Z. unmglich!")
        EXIT
    END
END
IF !EMPTY(wi)
    swclose(wi)
END
RETURN ret


**********************
FUNC myAppend(lUnLock)
//Satz anfgen mit Fehlerabfrage
LOCAL lRet:=.f.
IF lUnlock==NIL
    lUnLock:=.t.
END
#ifdef __XPP__
DBAPPEND(IIF(lUnLock, 0, 1))
#else
DBAPPEND(lUnLock)
#endif
IF lRet:=NETERR()
    ALERT(ne2 + ":;" + ALIAS())
END
RETURN !lRet


******************
FUNC netuse(f,a,i)
LOCAL r:=.f.
USE (f) ALIAS (a) SHARED NEW
IF (r:=NETERR())
    ALERT("Open-Error: " + f)
ELSE
    IF !(i=NIL)
        SET INDEX TO (i)
    END
END
RETURN !r


*************
FUNC tab_in()
//Eingabe auf aktueller Screenposition in browse-Objekt
LOCAL col, get, curs:=SETCURSOR(1), n:=0, nDC:=DISPCOUNT()
PARAMETERS x    // Variable

FOR n := 1 TO nDC   // (LIN 25.09.2009, LUD 28.09.2009) Eingabe unsichtbar
    DISPEND()       // fr "Edit in Liste", z.B. Bestellung/F2->Wareneingang
NEXT
col:=browse:getColumn(browse:colPos)
get:=GetNew(Row(), Col(), MEMVARBLOCK("x"), col:heading,, browse:colorSpec)
ReadModal({get})
SETCURSOR(curs)
FOR n := 1 TO nDC
    DISPBEGIN()
NEXT
RETURN x


****************************************************************
*   Dialog "Datei ffnen"
*
*

****************
FUNC fopen_dlg()
// File open - Dialog
LOCAL   aFeld:={}, aFiles:={}, cFile:="", nWahl:=0,;
        aft:=futa({}), wi:={}, wi1:={}, wi2:={}, cRet:="", i:=0
PRIVATE lchLW:=.f.
PARAMETERS spez, cPath  //z.B. spez=".txt"
wi:=swopen(5,15,21,64, "Datei ffnen", farbe3)
SETCOLOR(farbe2)
@ 1,25 SAY "ALT_W"
@ 2,25 SAY "Laufwerk wechseln"
wi1:=swopen(6,17,16,35)

//IF EMPTY(spez)
//    spez:="*.*"
//END
spez:=UPPERG(spez)
IF EMPTY(cPath)
    cPath:=DISKNAME() + IF(EMPTY(CURDIR()), ":", ":\" + CURDIR())
END

WHILE EMPTY(cFile)

    aFeld := DIRECTORY(cPath + "\*.*","D")
    ASORT(aFeld,,, {|x,y| IF("D"$x[5],"1","2")+x[1] < IF("D"$y[5],"1","2")+y[1] })
    aFiles:={}
    i:=1

    //Vorbereitung Auswahlmen, bernahme Datei- und Verzeichnisnamen
    //Dateinamen in Kleinschreibung umwandeln
    //ggf. nach Dateierweiterung filtern
    WHILE i<=LEN(aFeld)
        IF "D" $ aFeld[i,5] .OR. EMPTY(spez) .OR. spez $ UPPERG(aFeld[i,1])
            AADD(aFiles, IF(aFeld[i,5]="D", aFeld[i,1], LOWER(aFeld[i,1]) ))
        END
        i++
    END

    cPt:= cPath + IF(EMPTY(spez), "", "\*" + spez)
    IF LEN(cPt) < 30
        cPt:=PADR(cPt,30)
    END
    wi2:=swopen(17, 17, 20, 21+LEN(cPt), "Pfad")
    @ 1,0 SAY cPt
    wselect(wi1[2])
    CLS
#ifdef GUI
    KEYBOARD ""    // Clear buffer to avoid possible loop
#endif
    nWahl:=ACHOICE(0, 1, maxrow(), maxcol()-1, aFiles, , "fofnc")
    swclose(wi2)
    DO CASE
        CASE lchLW
            lchLW:=.f.
        CASE nWahl==0
            EXIT
        CASE aFiles[nWahl] == "."
        CASE aFiles[nWahl] == ".."
            cPath:=LEFT(cPath, RAT("\", cPath)-1)
        CASE "D" $ aFeld[nWahl,5]
            cPath += "\" + aFiles[nWahl]
        OTHERWISE
            cFile:=aFiles[nWahl]
            cRet:=cPath +"\" + cFile
    END
END

swclose(wi1)
swclose(wi)
restfuta(aft)
RETURN cRet


*******************************
FUNC fofnc(nMode, nPos, nZeile)
LOCAL nKey:=0, nRet:=AC_CONT
lFlag:=.f.
DO CASE
    CASE nMode==AC_IDLE
    CASE nMode==AC_HITTOP
    CASE nMode==AC_HITBOTTOM

    CASE nMode==AC_EXCEPT
        nKey:=LASTKEY()
        DO CASE
            CASE nKey==K_ESC
                nRet:=AC_ABORT
            CASE nKey==K_RETURN
                nRet:=AC_SELECT
            CASE nKey==K_ALT_W
                lw_change()
                lchLW:=.t.
                nRet:=AC_ABORT
            OTHERWISE
                nRet:=AC_GOTO
        END

    CASE nMode==AC_NOITEM
END
RETURN nRet


****************
PROC lw_change()
//fr fopen_dlg(), Laufwerk wechseln
LOCAL   aLW:={}, n:=0, lTest:=.f.,;
        cLW:=DISKNAME(),;                   //LW merken
        wi:=swopen(6,17,16,35,"Laufwerke")
SETCOLOR(farbe2)
CLS
FOR n=1 TO 26                               //verfgbare LW ermitteln
    IF DISKCHANGE( CHR(n+64) )
        AADD(aLW, CHR(n+64))
    END
NEXT
DISKCHANGE(cLW)                             //LW wiederherstellen
n:=ACHOICE(1,0,MAXROW(),MAXCOL(), aLW)
swclose(wi)
IF n>0
    wi:=meldung("Prfe LW " + aLW[n])
    lTest:=DISKREADY(aLW[n])                //Bereitschaft prfen
    del_meld(wi)
    IF lTest
        cPath:=aLW[n] +":"
    ELSE
        ALERT("Kein Datentrger in LW " + aLW[n])
    END
END
RETURN


/*
*************
FUNC cd_dlg()
// change directory - Dialog
LOCAL   aDir:={}, aFeld:={}, aFiles:={}, nWahl:=0,;
        aft:=futa({}), wi:={}, wi1:={}, wi2:={},;
        cPath:=""
PRIVATE lchLW:=.f.

wi:=swopen(5,15,21,64, "Verzeichnis wechseln", farbe3)
SETCOLOR(farbe2)
@ 1,25 SAY "ALT_W"
@ 2,25 SAY "Laufwerk wechseln"
wi1:=swopen(6,17,16,35)

WHILE .t.

    cPath:=DISKNAME() + IF(EMPTY(CURDIR()), ":", ":\" + CURDIR())
    aDir:=DIRECTORY(cPath + "\*.*", "D")
    aFeld:={}
    AEVAL(aDir, {|x| IF(x[5]="D", AADD(aFeld, x), NIL) })
    ASORT(aFeld,,, {|x,y| x[1] < y[1] })
    aFiles:={}
    AEVAL(aFeld, {|x| AADD(aFiles, x[1]) })

    cPt:= cPath
    IF LEN(cPt) < 30
        cPt:=PADR(cPt,30)
    END
    wi2:=swopen(17, 17, 20, 21+LEN(cPt), "Pfad")
    @ 1,0 SAY cPt
    wselect(wi1[3])
    CLS
    nWahl:=ACHOICE(0, 1, maxrow(), maxcol()-1, aFiles, , "fofnc")
    swclose(wi2)
    DO CASE
        CASE lchLW
            lchLW:=.f.
            cPath:=DISKNAME() + IF(EMPTY(CURDIR()), ":", ":\" + CURDIR())
        CASE nWahl==0
            EXIT
        CASE aFiles[nWahl] == "."
        CASE aFiles[nWahl] == ".."
            DIRCHANGE("..")
        CASE "D" $ aFeld[nWahl,5]
            DIRCHANGE( aFiles[nWahl] )
    END
END
swclose(wi1)
swclose(wi)
restfuta(aft)
RETURN cPath
*/


*******************
PROC exp_dbf(cDest)
//temp. Datei exportieren
LOCAL wi:=swopen(10,15,14,64, "Export",farbe3), nRec:=RECNO()

DISPBEGIN()
SETCOLOR(farbe2)
SETCURSOR(1)
cDest:=PADR(cDest, 50)
@ 1,0 SAY "Zieldatei:" GET cDest PICTURE "@s30"
DISPEND()
READ
IF LASTKEY()<>27 .AND. !EMPTY(cDest)
    cDest := ALLTRIM(cDest)
    IF UPPER(LEFT(cDest, 2)) <> UPPER(LEFT(ALLTRIM(si_path), 2))
        ALERT("Zieldatei darf nur auf Laufwerk " +;
              UPPER(LEFT(ALLTRIM(si_path), 2)) + " sein!")
    ELSEIF !FILE(cDest) .OR.;
     ALERT("Zieldatei existiert bereits",;
     {"berschreiben","Abbruch"})==1
        IF IsAnyMark()
            COPY TO (cDest) FOR IsMark(RECNO()) VIA (cDBECDX)
        ELSE
            COPY TO (cDest) VIA (cDBECDX)
        END
        DBGOTO(nRec)
    END
END
swclose(wi)
RETURN


*******************
PROC exp_csv(cDest)
//temp. Datei als CSV (kommasepariertes Text) exportieren
LOCAL wi:=swopen(10,15,14,64, "Export CSV",farbe3), nRec:=RECNO(),;
      i:=0, nFields:=FCOUNT(), aStruct:=DBSTRUCT(), c:="", t:=""

DISPBEGIN()
SETCOLOR(farbe2)
SETCURSOR(1)
cDest:=PADR(cDest, 50)
@ 1,0 SAY "Zieldatei:" GET cDest PICTURE "@s30"
DISPEND()
READ
IF LASTKEY()<>27 .AND. !EMPTY(cDest)
    cDest:=TRIM(cDest)
    IF !FILE(cDest) .OR.;
     ALERT("Zieldatei existiert bereits",;
     {"berschreiben","Abbruch"})==1
        nHandle := FCREATE(cDest)
        DBGOTOP()
        WHILE !EOF()
            c := ""
            FOR i := 1 TO nFields
                IF i > 1
                    c += ","
                END
                t := aStruct[i, DBS_TYPE]
                IF t == "C" .OR. t == "M"
                    c += '"' + DOS2WIN(STRTRAN(ALLTRIM(FIELDGET(i)), '"', '""')) + '"'
                ELSEIF t == "D"
                    c += DTOC4(FIELDGET(i))
                ELSE
                    c += ALLTRIM(STR(FIELDGET(i)))
                END
            NEXT
            FWRITE(nHandle, c + cr)
            DBSKIP()
        END
        FCLOSE(nHandle)
        DBGOTO(nRec)
    END
END
swclose(wi)
RETURN


************
FUNC CSVline(a)
LOCAL c:="", i:=0
FOR i := 1 TO LEN(a)
    c += IIF(i=1, "", ",") + '"' + DOS2WIN(STRTRAN(a[i], '"', '""')) + '"'
NEXT
RETURN c + cr


****************************************************************
// Datenbank (bzw. Auszug) drucken

****************
FUNC printdbf2()
//druckt dbf als Tabelle
//Spalten whlbar, Relationen zulssig
LOCAL;
    ab:=.t.,;         // log. Var. fr Druck fortsetzen
    err_bl,;          // erhlt ursprngliche Error-Handler
    satz:=RECNO(),;   // aktueller Satz
    seite:=1,;        // Seitennummer
    smax:=0,;         // letzte mgliche Druckseite
    smaxw:=0,;        // letzte gewhlte Druckseite
    snr:=1,;          // Satznummer
    wi:={},;          // Feld fr Fensterinfos
    zmax:=56,;        // Datenstze (Tabellen-Zeilen) pro Seite
    x,;               // fr alles Mgliche...
    nrecs:=0,;        // Anzahl der zu druckenden Stze
    cDateiname:="",;  // Vorblendwert fr "Druck in Datei" (max 8 Zeichen)
    cDest:="",;       // Zieldatei (Pfad\Name.txt) fr "Druck in Datei"
    yn:="N",;
    lPrint2File:=.f.,;
    lQuit:=.f.,;
    lRet:=.f.
PARAMETERS;
    fe,;       // enthlt die Datenbankfelder, z.B. {"ar->nr", "bv->name"}
    ko1, ko2,; // Kopfzeilen
    fu1, fu2,; // Fuzeilen
    _pos,;     // log. Parameter: laufende Nummer EIN/aus
    sc,;       // log. Parameter: Schmalschrift EIN/aus
    zz         // log. Parameter: 2-zeilig EIN/aus

cDateiname := MakeDOSfilename(ko1)
cDest:=PADR(dok_path + "\" + cDateiname + ".txt", 50)

//zu druckende Stze zhlen
wi:=meldung()
COUNT TO nrecs
del_meld(wi)

// Abbruch, falls dbf leer
IF nrecs=0
    ALERT("Kein Datensatz vorhanden")
    RETURN lRet
END

// Initialisierung
_pos := IF(_pos==NIL,.f.,_pos)
sc  := IF(sc==NIL,.t.,sc)
zz  := IF(zz==NIL,.f.,zz)
//wenn keine Feldliste bergeben wurde, dann alle Felder in Feldliste
IF fe=NIL
    x:=1
    fe:={}
    WHILE x <= FCOUNT()
        AADD(fe, FIELDNAME(x++))
    END
END
ko1 := IF(ko1==NIL,"",ko1)
IF ko2=NIL
    x:=1
    ko:=""
    WHILE x <= LEN(fe)
        ko += PADR(fe[x], FIELDSIZE(FIELDNUM(fe[x++]))) + "  "
    END
END
ko2:=IF(_pos, "Pos. " + ko2, ko2)
fu1:=IF(fu1==NIL, "SINUS Messtechnik GmbH";
                 + SPACE(IF(sc,78,33)) + DTOC4(date()), fu1 )
fu2:=IF(fu2==NIL, fu2:=ALIAS(), fu2)

// Druckseiten auswhlen
smax:=smaxw:= INT( (IF( zz, 2*nrecs, nrecs) + zmax - 1 )/ zmax)

wi:=swopen(9,17,16,62,"Drucken", "w+/r,n/w")
DISPBEGIN()
SETCURSOR(1)
@ 1,0 SAY "ab Seite:" GET seite;
  PICTURE "999" VALID seite>0 .AND. seite<=smax
@ 1,COL()+1 SAY "bis Seite:"  GET smaxw;
  PICTURE "999" VALID smaxw>=seite .AND. smaxw<=smax
@ 3,0 SAY "Druck in Datei (J/N):" GET yn;
  PICTURE "!" VALID yn $ "JN"
@ 4,0 SAY "Zieldatei:" GET cDest PICTURE "@s30"
DISPEND()
READ
swclose(wi)

lQuit := (LASTKEY()=27)
lPrint2File := (yn=="J")
IF lPrint2File .AND. !lQuit
    lPrint2File := print2file(.t., cDest, .f., .f.)
    lQuit := !lPrint2File
END

IF !lQuit

    // Zeiger auf ersten zu druckenden Satz setzen
    DBGOTOP()
    SKIP (seite-1) * IF(zz, zmax/2, zmax)

    // Druckbereitschaft prfen
    IF lPrint2File .OR.;
             (ALERT("Blatt " + LTRIM(STR(seite,2)) + " von ";
                   + LTRIM(STR(smaxw,2))+ " einlegen!") = 1 .AND. pr_okay())
        err_bl:=ERRORBLOCK({ |x| PrintErr(x) })
        wi:=swopen(10,26,14,52,,"W+/R")
        ? PADC("Es wird gedruckt", MAXCOL()+1)
        BEGIN SEQUENCE
            prON(sc, lPrint2File)

            // Druckschleife
            WHILE (seite<=smaxw)  //ab

                IF PROW()=0 //Druckzeile=0, so drucke Kopfzeilen
                    ?? ko1
                    ?  ko2
                    ?  IF(ko2=="","",;
                         REPLICATE(CHR(196), IF(sc, MAX(110,LEN(ko2)), 65)))
                END

                // eine Datenzeile drucken
                ? IF(_pos, PADR(snr++, 3) + "  ", "")
                AEVAL(fe, {|x| udf2(x) })
                IF zz
                    ? ""      // Leerzeile, falls 2-zeilig
                END

                DBSKIP(1)

                IF EOF()
                    WHILE PROW()<zmax+2
                        ?
                    END
                END

                IF PROW()=zmax+2
                    // Fuzeile drucken
                    ? REPLICATE(CHR(196), IF(sc, 110, 65))
                    ? fu1
                    ? fu2
                    ?? SPACE(IF(sc, 110,65) - LEN(fu2) - 11)
                    ?? "Seite " + STR(seite++,2) + "/" + STR(smax,2)
                    EJECT   // Blatt rauswerfen
                    lRet:=.t.
                    IF seite<=smaxw .AND. !lPrint2File
                        ALERT("Blatt " + LTRIM(STR(seite,2)) + " von ";
                              + LTRIM(STR(smaxw,2))+ " einlegen!")
                    END
                END

                // Druckpause mit ESC
                IF INKEY()=27 .AND. ALERT("Druckpause",;
                                    {"Fortsetzen","Abbruch"})=2
                    EXIT
                END

            END
            prOFF(lPrint2File)
        RECOVER
            prOFF(lPrint2File)
        END SEQUENCE
        swclose(wi)
        ERRORBLOCK(err_bl)
        IF lPrint2File
            print2file(.f., cDest, .f., .f.)
        END
    END
END
DBGOTO(satz)
RETURN lRet

***********
PROC udf2()
//zu printdbf2()
PARAMETERS expr
IF expr="cr"
    ? ""    //Zeilevorschub
ELSE
    ?? &expr, " "
END
RETURN

****************
PROC PrintErr(x)
TONE(880,1)
ALERT("Print-Error: "+ PADR(x,5), {"Abbruch"})
BREAK x
RETURN


****************************************************************
// versch. Druckfunktionen

**************
FUNC pr_okay()
//  gibt .T., wenn Drucker bereit
// neu: lprmode==.t.: Druck in Datei, also immer ready

LOCAL lRet:=.f.
WHILE !(lRet:=ISPRINTER() .OR. lprmode)
    TONE(880,1)
    IF ALERT("Drucker nicht OnLine;Prfe Drucker/ Papierzufuhr",;
    {"Neuer Versuch","Abbruch"}) = 2
        EXIT
    END
END
RETURN lRet


***************
FUNC pr_left(n)
//aPP[1]: linker Rand
RETURN EVAL(aPP[1],n)

***************
FUNC pr_draft()
//aPP[2]: Draft
RETURN aPP[2]

************
FUNC pr_lq()
//aPP[3]: Letter (Standard)
RETURN aPP[3]

***************
FUNC pr_cpi15()
//aPP[4]: 15 CPI setzen
RETURN aPP[4]

***************
FUNC pr_cpi10()
//aPP[5]: 10 CPI setzen (Standard)
RETURN aPP[5]

***************
FUNC pr_sm_on()
//aPP[6]: Schmaldruck EIN
RETURN aPP[6]

****************
FUNC pr_sm_off()
//aPP[7]: Schmaldruck AUS (Standard)
RETURN aPP[7]

**************
FUNC pr_qg10()
//aPP[8] Schriftart Quick_Gotic_10 on EIN
RETURN aPP[8]

**************
FUNC pr_co10()
//aPP[9] Schriftart Courier_10 EIN
RETURN aPP[9]

*************
FUNC pr_or()
//aPP[10] oberer Rand
RETURN aPP[10]

**************
FUNC pr_f_on()
//aPP[11] Fett EIN
RETURN aPP[11]

***************
FUNC pr_f_off()
//aPP[12] Fett AUS
RETURN aPP[12]

************
PROC SetPrinterTo()
SET PRINTER TO
IF oXbpPrinter != NIL
    SET PRINTER TO OBJECT oXbpPrinter
END
RETURN

************
PROC prON(s, lPrint2File)
IF lPrint2File == NIL
    lPrint2File := .f.
END
SET CONSOLE OFF
SET PRINTER ON
IF !lPrint2File
    ?? aPP[13]  //Init
    IF s
        ?? pr_qg10()    //Quick Gotic 10
        ?? pr_sm_on()   //schmal EIN
        ?? pr_draft()   //Draft On
        ?? pr_left(14)  //linker Rand 14
    ELSE
        ?? pr_left(6)   //linker Rand 6
    END
    ?? pr_or()          //oberer Rand
END
RETURN

************
PROC prOFF(lPrint2File)
IF lPrint2File == NIL
    lPrint2File := .f.
END
IF lPrint2File
    ?? SPACE(4)     // sonst fehlen die letzte 4 Zeichen!
ELSE
    ?? pr_lq()      //Draft Off
    ?? " "
    ?? pr_sm_off()  //schmal AUS
    ?? " "
    ?? pr_co10()    //Courier 10 (Standard)
    ?? " "
    ?? pr_left(0)   //linker Rand 0
    ?? " "
END
#ifdef __XPP__
SetPrinterTo()      // Druck-Job beenden, sonst bleibt im Spooler stecken
#endif
SET PRINTER OFF
SET CONSOLE ON
RETURN


****************************************************************
// Textdokument drucken

**************************
FUNC text_print(text, nCol, nLang, cDateiname, cFormNum, aFettZeilen, lNoHeader)
// Druckt Text zeilenweise.
// cFormNum wird (fett) gedruckt vor "Blatt" oben auf Seite 2...n.
// aFettZeilen macht 1. Vorkommen von jedem String im Array fett (bis Zeilenende).
LOCAL r:=.f., wi:={}, i:=0, j:=0, k:=0, m:=0, nPosFZ:=0, uspos:=0, nAuswahl:=0, MaxL:=0,;
      bnr:=1, bnrmax:=1,;           //Blattnummer, max.
      cLine:="", cStrich:="",;      //Textzeile, Unterstrich
      cDest:="", cBlatt:="",;       //Zieldatei-Name, Blatt-Text
      cEmail:="N",;
      cRunEmail:="", cRunEmailProg:="",;
      lflag1:=.f.,;                 //schmal=Nein
      lPrint2File:=.f., lPDF:=.f.,;
      cName:="", cPath:=dok_path

IF nLang=NIL
    nLang:=1   // Sprache deutsch falls nicht bergeben
END
IF lNoHeader=NIL
    lNoHeader := .f.   // Kopfbogen nutzen falls nicht bergeben
END
cBlatt:=tk[39,nLang]   // "Blatt" oder "Page"
IF cDateiname=NIL
    cDateiname:="formular"
END
cDateiname := MakeDOSfilename(cDateiname)   // cDateiname max. 8 Zeichen
IF cFormNum=NIL
    cFormNum := ""
ELSE
    cFormNum := pr_f_on() + cFormNum + pr_f_off() + "  "
END
IF aFettZeilen=NIL
    aFettZeilen := {}
END

nAuswahl:=ALERT("Dokument drucken",{"Ja","Nein","Datei","PDF"})
lPDF := (nAuswahl==4)
IF nAuswahl==3 .OR. lPDF
    wi:=swopen(10,15,15,64, "Druck in " + IIF(lPDF, "PDF ", "") + "Datei",farbe3)
    DISPBEGIN()
    SETCOLOR(farbe2)
    SETCURSOR(1)
    FOR i := 1 TO LEN(x_dok_names)
        cName := x_dok_names[i]
        IF UPPER(LEFT(cDateiname, LEN(cName))) == cName   // Lieber LEFT() als auf SET EXACT OFF verlassen
            cPath := x_dok_paths[i]
            EXIT
        END
    NEXT
    cDest:=PADR(cPath + "\" + cDateiname + "." + IIF(lPDF, "pdf", "txt"), 50)
    @ 1,0 SAY "Zieldatei:" GET cDest PICTURE "@s30"
    @ 2,0 SAY "    Email:" GET cEmail PICTURE "!" VALID cEmail $ "JN"
    DISPEND()
    READ
    IF LASTKEY()<>27
        lPrint2File := print2file(.t., cDest, lPDF, lNoHeader)
    END
    swclose(wi)
END

IF lPrint2File .OR. (nAuswahl==1 .AND. pr_okay())

    wi:=meldung("Druck luft")
    //text:=STRTRAN(text, "SINUS", pr_f_on() + "SINUS" + pr_f_off())
    prOn(.f.)

    //Zeilenzahl
    j:=MLCOUNT(text,nCol)

    i:=1
    WHILE i<=j
        cLine:=TRIM(MEMOLINE(text,nCol,i++))
        IF cLine = REPLICATE(CHR(196),10)
            uspos:=i-2  //Position Tabellenberschrift merken
            cStrich:=cLine //Unterstrich merken
            lflag1:=(LEN(cLine) > 71) //schmal EIN
            EXIT
        END
    END

    //Textzeilen pro Blatt:
    //1.Blatt: MAXLINES-1, Folgebltter: MAXLINES+EXTRALINES-HDRLINES-1
    i := j + 1 - MAXLINES
    WHILE i > 0
        i -= MAXLINES + EXTRALINES - HDRLINES - 1
        bnrmax++
    END

    //Text zeilenweise drucken: i=Eingangszeile, j=Gesamtanzahl, k=Tabellenzustand (0:vor, 1:whrend, 2:nach)
    i:=1
    WHILE i<=j
        cLine:=MEMOLINE(text,nCol,i++)
        FOR m := 1 TO LEN(aFettZeilen)
            nPosFZ := AT(aFettZeilen[m], cLine)
            IF nPosFZ > 0
                cLine := LEFT(cLine, nPosFZ-1) + pr_f_on() + SUBSTR(RTRIM(cLine), nPosFZ) + pr_f_off()
                ADEL(aFettZeilen, m)
                ASIZE(aFettZeilen, LEN(aFettZeilen)-1)
                EXIT
            END
        NEXT

        // Textzeile drucken
        ? TRIM(cLine)

        IF lFlag1 .AND. i==uspos-1  //Zeile vor Tabellenbeginn
            ?? pr_cpi15()              //schmal EIN
        END

        IF cLine=REPLICATE(CHR(196), 10)    //Unterstrichzeile
            k++
            IF lFlag1 .AND. k==2    //Ende der Tabelle
                ?? pr_cpi10()       //schmal AUS
            END
        END

        //falls Seite voll bzw. falls Gruformel nicht mehr
        //auf Seite pat => neues Blatt
        IF bnr==1
            MaxL := MAXLINES            // 1. Seite fngt tiefer an!
        ELSE
            MaxL := MAXLINES+EXTRALINES
        END
        IF PROW()=MaxL-1 .OR.;
          (MEMOLINE(text,nCol,i)=tk[15,nLang] .AND. PROW()>(MaxL-3))
            IF k==1 //falls Tabelle nicht abgeschlossen, Linie drucken
                IF MEMOLINE(text,nCol,i)=REPLICATE(CHR(196), 10)
                    IF PROW()==MaxL-1   // Linie unterdrcken wenn diese allein auf einem Blatt stehen wrde...
                        i++             // ...e.g. O-1150275.4734 mit einer Zeile weniger im Anfangstext
                    ELSE
                        ? MEMOLINE(text,nCol,i++)
                    END
                    IF lFlag1
                        ?? pr_cpi10()
                    END
                    k++
                ELSE
                    IF bnr==1
                        ? PADL(cBlatt + " 1/" + STR(bnrmax,2), LEN(cStrich)-10)
                    END
                    // ? cStrich //Strich drucken
                END
            END
            EJECT
            IF i<j
                IF !lPrint2File   // kein ALERT beim Druck in Datei
                    FlushPrinter()  // "Gedruckte" Seiten wirklich drucken
                    IF !(ALERT("Neues Blatt einlegen", {"Weiter","Abbruch"})==1;
                     .AND. pr_okay())
                        EXIT
                    END
                END
                ?       // Diese 7 Druckzeilen bestimmen #define HDRLINES
                ?
                ?
                ? cFormNum + cBlatt + " " + STR(++bnr,2) + "/" + STR(bnrmax,2)
                ?
                //Tabellenberschrift
                ? IF(k==1, MEMOLINE(text,nCol,uspos), "")
                //Linie unter Tabellenberschrift
                ? IF(k==1, cStrich, "")
            END
        END
    END
    IF PROW()>0
        EJECT
    END
    prOff()
    del_meld(wi)
    r:=.t.
END

IF lPrint2File
    print2file(.f., cDest, lPDF, lNoHeader)
    IF cEmail=="J"
        cRunEmailProg := DC_RegQuery(, "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\thunderbird.exe", "")
        IF EMPTY(cRunEmailProg)
            ALERT("Thunderbird nicht im Registry gefunden (HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\thunderbird.exe)!")
        ELSE
            cRunEmail := "-compose to='" + lk->email + "',subject='SINUS',attachment='" + RTRIM(cDest) + "'"
            RunShell(cRunEmail, cRunEmailProg, .T.)
        END
    END
END

RETURN r


****************************************************************
// "Gedruckte" Seiten wirklich drucken

**************************
PROC FlushPrinter()

//prOFF()
//prON(.f.)
SetPrinterTo()
SET PRINTER OFF
SET PRINTER ON
RETURN


****************************************************************
// Druck in Datei (lFile=.t.), beenden mit lFile=.f. - immer
// paarweise benutzen (abhngig vom Erfolg des "lFile=.t."-Aufrufs).
// cDest ist Zieldatei-Name.
// Logische Rckgabewert (lRet) bedeutet Erfolg.
****************************************************************

function print2file(lFile, cDest, lPDF, lNoHeader)

STATIC lprmode_alt,;                          // akt. Druckmodus und...
       aPP_alt,;                              // ...Steuerbefehle behalten
       cDest_alt:="",;                        // vorheriger Dateiname
       cDest_PDF:=""

LOCAL  cMemo:="",;                            // Zieldatei-Inhalt
       lRet:=.f.,;                            // Rckgabewert
       nFile:=0,;
       nPos:=0

cDest:=TRIM(cDest)
IF !EMPTY(cDest)
    nPos := RAT("\", cDest)
    IF nPos == 0 .OR. testpath(LEFT(cDest, nPos-1))
        IF lFile
            IF EMPTY(cDest_alt) .AND. (!FILE(cDest) .OR.;
                                       ALERT("Zieldatei existiert bereits",;
                                             {"berschreiben","Abbruch"})==1)
                lprmode_alt:=lprmode
                aPP_alt:=ARRAY(LEN(aPP))
                ACOPY(aPP,aPP_alt)                // akt. Steuerbefehle behalten
                lprmode:=.t.                      // Druck in Datei immer bereit...
                AFILL(aPP,"")                     // ...und ohne Steuerbefehle...
                IF lPDF                           // ...auer "Pseudobefehle" fr PDF.
                    aPP[11] := CHR(27) + "(s3B"
                    aPP[12] := CHR(27) + "(s0B"
                END
                aPP[1] := {|n| SPACE(n) }
                IF lPDF
                    cDest_PDF := TEMPFILE(dok_path, "tmp")
                    SET PRINTER TO (cDest_PDF)
                ELSE
                    SET PRINTER TO (cDest)
                END
                cDest_alt:=cDest
                lRet:=.t.
            END
        ELSE
            IF cDest == cDest_alt
                SetPrinterTo()
                lprmode:=lprmode_alt   // Druckmodus und...
                ACOPY(aPP_alt,aPP)     // ...Steuerbefehle wiederherstellen
                cMemo:=MEMOREAD(IIF(lPDF,cDest_PDF,cDest))           // Zieldatei nachbearbeiten:
                IF !lPDF
                    cMemo:=STRTRAN(cMemo,aPP[11],"")                 // 1. Steuerbefehl "Fett ein" entfernen
                    cMemo:=STRTRAN(cMemo,aPP[12],"")                 // 2. Steuerbefehl "Fett aus" entfernen
                END
                cMemo:=LEFT(cMemo, LEN(cMemo)-6)                     // 3. Seitenwechsel am Ende entfernen
                nFile := FCREATE(IIF(lPDF,cDest_PDF,cDest))
                FWRITE(nFile, DOS2WIN(cMemo))                        // 4. Windows-gerecht zurckschreiben
                FCLOSE(nFile)
                IF lPDF
                    RUN ("w:\php\php w:\txt2pdf.php " + Quote(cDest_PDF) + IIF(lNoHeader, " /NoHeader", "") + " >" + Quote(cDest))
                    DELETE FILE (cDest_PDF)
                    RUN ("CMD /C START " + Quote(cDest) + " " + Quote(cDest))  // PDF-Datei anzeigen mit Windows-Standardprogramm
                END
                cDest_alt:=""
                lRet:=.t.
            END
        END
        END
END

RETURN lRet


****************************************************************
// OEM- zu ANSI-Zeichen konvertieren
****************************************************************

FUNC DOS2WIN(cString)
LOCAL i:=0, aConvert := {;   // {DOS, Windows} - nur wahrscheinliche Zeichen
                         {128, 199},;    // 
                         {130, 233},;    // 
                         {132, 228},;    // 
                         {133, 224},;    // 
                         {134, 229},;    // 
                         {135, 231},;    // 
                         {136, 234},;    // 
                         {138, 232},;    // 
                         {143, 197},;    // 
                         {144, 201},;    // 
                         {147, 244},;    // 
                         {148, 246},;    // 
                         {153, 214},;    // 
                         {154, 220},;    // 
                         {164, 241},;    // 
                         {165, 209},;    // 
                         {196, 151},;    // -
                         {205, 061},;    // =
                         {225, 223},;    // 
                         {226, 212},;    // 
                         {230, 181},;    // 
                         {248, 176},;    // 
                         {252, 179},;    // 
                         {253, 178},;    // 
                         ; // Folgende zuletzt wegen "doppelte Konvertierung"...
                         {129, 252},;    // 
                         {131, 226},;    // 
                         {142, 196},;    // 
                         {160, 225};     // 
                        }

FOR i := 1 TO LEN(aConvert)
    cString := STRTRAN(cString, CHR(aConvert[i,1]), CHR(aConvert[i,2]))
NEXT

RETURN cString


****************************************************************
// 8-Zeichen DOS-Dateiname (ohne Erweiterung) aus cString basteln...
****************************************************************

FUNC MakeDOSfilename(cString, lLongName)

IF lLongName == NIL .OR. !lLongName
    cString := RIGHT(RTRIM(cString), 8)
END
cString := CHARREPL(CHARNOLIST("ABCDEFGHIJKLMNOPQRSTUVWXYZ"+;
                               "abcdefghijklmnopqrstuvwxyz"+;
                               "0123456789!#$%&()-@_~."),;
                    cString,;
                    "_")
IF EMPTY(cString)
    cString := "zzzzzzzz"
END
RETURN cString


****************************************************************
// Datumswert in String mit 4-stelligem Jahr (dd.mm.yyyy) umwandeln
****************************************************************

FUNC DTOC4(d)
LOCAL s:=DTOS(d)

RETURN RIGHT(s,2) + "." + SUBSTR(s,5,2) + "." + LEFT(s,4)


****************************************************************
// String "intelligent" in Hochkommas setzen
****************************************************************

FUNC Quote(c)
LOCAL ql:=qr:='"'
IF AT('"', c) > 0
    IF AT("'", c) > 0
        ql:="["
        qr:="]"
    ELSE
        ql:=qr:="'"
    END
END
RETURN ql + c + qr

//#ifndef __XPP__
****************************************************************
// String in Grobuchstaben umwandeln - auch Umlaute!
****************************************************************

FUNC UPPERG(cBegriff)
cBegriff:=UPPER(cBegriff)
cBegriff:=STRTRAN(cBegriff, "", "")
cBegriff:=STRTRAN(cBegriff, "", "")
cBegriff:=STRTRAN(cBegriff, "", "")
RETURN cBegriff
//#endif

****************************************************************
****************************************************************
****************************************************************

/*
*****************
FUNC myDBRLock(n)
// Satz sperren mit Warteschleife
LOCAL ret, i:=10, wi
WHILE !(ret:=DBRLOCK(n))
    IF EMPTY(wi)
        wi:=meldung()
    END
    IF i>0
        i--
//        INKEY(0.2) // warte 0,2 Sekunden
    ELSE
        ALERT(ALIAS()+":;"+ne1)
        EXIT
    END
END
IF !EMPTY(wi)
    del_meld(wi)
END
RETURN ret
*/


****************************************************************
// Akt. Datensatz in Array speichern (fr Kopierfunktionen)
****************************************************************

FUNC GetRec(aRec)
LOCAL i:=0, n:=FCOUNT()

ASIZE(aRec, 0)
FOR i := 1 TO n
    AADD(aRec, FIELDGET(i))
NEXT

RETURN aRec


****************************************************************
// Array in akt. Datensatz speichern (fr Kopierfunktionen)
****************************************************************

FUNC PutRec(aRec)
LOCAL i:=0, n:=FCOUNT()

FOR i := 1 TO n
    FIELDPUT(i, aRec[i])
NEXT

RETURN aRec


****************************************************************
// Kompatibilittsfunktion fr Xbase/ADS (aus dbesys.prg)
****************************************************************

FUNCTION _OrdListAdd(cFile)
LOCAL xRet, aList, nLen
xRet := ORDLISTADD(cFile)
#ifdef __XPP__
IF DbeSetDefault() == "ADSDBE"
  aList := OrdList()
  nLen  := Len(aList)
  IF nLen > 0
    OrdSetfocus(1)
  ENDIF
ENDIF
#endif
RETURN xRet


****************************************************************
// cText krzen zu nLen mit "..." falls ntig
****************************************************************

FUNC DotDotDot(cText, nLen)

IF LEN(TRIM(cText)) > nLen
    cText := LEFT(cText, nLen - 3) + "..."
ELSE
    cText := PADR(cText, nLen)
END
RETURN cText


****************************************************************
// Anwendung schlieen
****************************************************************

PROC Quit_App()
#ifdef FIBU
LOCAL cFeld:="in_fibu", cApp:="Fibu"
#else
LOCAL cFeld:="in_sima", cApp:="Sima"
#endif

#ifdef __XPP__
STATIC lQuit_App := .f.
IF lQuit_App
    QUIT    // Aufgeben falls Quit_App() schon luft, sonst Endlos-Rekursion
END
lQuit_App := .t.
IF !EMPTY(oDBServerSession) .AND. oDBServerSession:isConnected()
#endif
    IF !EMPTY(netuser)
        IF user_open()
            IF DBSEEK(netuser)
                IF myRLock()
                    user->&cFeld := IIF(user->&cFeld <= 0, 0, user->&cFeld - 1)
                    DBCOMMIT()
                    DBUNLOCK()
                ELSE
                    ALERT("Satzsperre gescheitert fr Benutzer " + user->benutzer +;
                          ";" + cFeld + " = " + user->&cFeld)
                END
            ELSE
                ALERT("Benutzer (" + netuser + ") nicht gefunden!")
            END
            CLOSE user
        ELSE
            ALERT("Benutzerdatei konnte nicht geffnet werden!")
        END
    END
#ifdef __XPP__
    COMMIT
    CLOSE ALL
    oDBServerSession:disconnect()
END
#else
    CLOSE ALL
#endif

SETCOLOR(farbe0)
CLS
?
? cApp + " beendet"

QUIT
RETURN  // berflssig, nur um Warnung zu vermeiden!


****************************************************************
// Schlssel aus cStr (Inhalt der Konfigurationsdatei) lesen
****************************************************************

FUNC getKey(cStr, cKey, cDefault)
LOCAL nPos:=0, cSubstr:="", nATCR:=0
nPos:=AT(cKey, cStr)
IF nPos==0
    IF cDefault==NIL
        ALERT('Eintrag "' + cKey + '" fehlt in Datei ' + cConfig)
    ELSE
        RETURN cDefault
    END
ELSE
    nPos += LEN(cKey) + 1
    cSubstr:=SUBSTR(cStr, nPos, 50)
END
nATCR := AT(cr, cSubstr)
RETURN IIF(nATCR>0, LEFT(cSubstr,nATCR-1), cSubstr)


****************************************************************
// Beliebigen Ausdruck zwischen <# und #> in Text substituieren
****************************************************************

FUNC Makro(cText)
LOCAL cRet:="", cMakro:="", nPos:=1, nAt:=0, nAt2:=0, bSaveErrorBlock, oError

WHILE nPos <= LEN(cText)
    nAt := AT("<#", cText, nPos)
    IF nAt == 0
        cRet += SUBSTR(cText, nPos)
        nPos := LEN(cText) + 1
    ELSE
        cRet += SUBSTR(cText, nPos, nAt - nPos)
        nAt2 := AT("#>", cText, nAt)
        IF nAt2 == 0
            cRet += SUBSTR(cText, nAt)
            nPos := LEN(cText) + 1
        ELSE
            bSaveErrorBlock := ErrorBlock( {|e| BREAK(e)} )
            BEGIN SEQUENCE
                cMakro := SUBSTR(cText, nAt + 2, nAt2 - nAt - 2)
                cRet += &(MEMOTRAN(cMakro, " ", " "))
            RECOVER USING oError
                cMakro := SUBSTR(cText, nAt, nAt2 - nAt + 2)
                cRet += cMakro
                ALERT("Fehler im Ausdruck:;" + cMakro + ";" + oError:description)
            END SEQUENCE
            ErrorBlock(bSaveErrorBlock)
            nPos := nAt2 + 2
        END
    END IF
END

RETURN cRet



*************
PROC logbrbl()
// Spalten der Tabelle zu artlog_disp(), lklog_disp()...

browse:addColumn(TBColumnNew("Datum",  {|| mod_dat } ))
browse:addColumn(TBColumnNew("Zeit",   {|| mod_zeit } ))
browse:addColumn(TBColumnNew("User",   {|| benutzer } ))
browse:addColumn(TBColumnNew("Felder", {|| felder } ))
RETURN


*************
PROC logfubl(cNrBez)
// Funktionen zur Tabelle, zu artlog_disp(), lklog_disp()...

DO CASE
    CASE nKey==K_ESC        //Tabelle schlieen
        lMore:=.f.

    CASE nKey==K_F9
        printdbf2(  {"DTOC4(mod_dat)", "mod_zeit", "benutzer", "felder"},;
                    "nderungen " + cNrBez,;
                    "Datum       Zeit      User  Felder",;
                    ,;      //Fuzeile 1
                    "",;    //Fuzeile 2
                    .f.,;   //laufende Nr.
                    .f.,;   //Schmalschrift
                    .f.)    //zweizeilig
END
RETURN


**************
FUNC ChangedFields(aOriginal, cTable, aIgnore)
// Ergibt Namen der genderten Feldern in akt. WA
// aOriginal soll mit GetRec() vor den nderungen initialisiert sein
// cTable wird zurckgegeben mit Feldnamen in Klammern (wenn nicht leer)
// aIgnore enthlt eventuell zu ignorierende Feldnummern (nicht Feldnamen!)

LOCAL i:=0, aNeu:={}, cRet:=""

IF aIgnore == NIL
    aIgnore := {}
END
GetRec(aNeu)
FOR i := 1 TO LEN(aOriginal)
    IF ASCAN(aIgnore,i)==0 .AND. !(aNeu[i]==aOriginal[i])
        cRet += FIELDNAME(i) + " "
    END
NEXT
IF EMPTY(cTable) .OR. EMPTY(cRet)
    RETURN cRet
END
RETURN cTable + "(" + TRIM(cRet) + ") "


************
FUNC iban_valid(cIBAN)
// IBAN-Prfsumme validieren.
// Siehe http://de.wikipedia.org/wiki/International_Bank_Account_Number#Validierung_der_Pr.C3.BCfsumme
//       http://www.iban.de/iban-pruefsumme.html
//       http://www.xbaseforum.de/viewtopic.php?f=6&t=6863

LOCAL cI := RTRIM(cIBAN), cN := "", c := ""

cI := SUBSTR(cI, 5) + SUBSTR(cI, 1, 4)

FOR i := 1 TO LEN(cI)
    c := SUBSTR(cI, i, 1)
    IF ISDIGIT(c)
        cN += c
    ELSEIF ISUPPER(c)
        cN += STR(10 + Asc(c) - Asc("A"), 2)
    ELSE
        RETURN .f.
    END
NEXT

RETURN (mod_str(cN, 97) == 1)


************
FUNC mod_str(cDividend, nDivisor)
// Modulusberechnung, wobei cDividend nur aus Ziffern bestehen darf aber ohne Lngenbeschrnkung ist.

IF LEN(cDividend) <= 9
    RETURN MOD(VAL(cDividend), nDivisor)
END

RETURN mod_str(ALLTRIM(STR(MOD(VAL(LEFT(cDividend, 9)), nDivisor))) + SUBSTR(cDividend, 10), nDivisor)


************
FUNC vorjahr(d)
LOCAL ys := STRZERO(YEAR(d)-1, 4), ms := STRZERO(MONTH(d), 2), ds := STRZERO(DAY(d), 2), dv := STOD(ys + ms + ds)

IF EMPTY(dv)
    ds := STRZERO(DAY(d) - 1, 2)  // Falls 29. Februar
    dv := STOD(ys + ms + ds)
END

RETURN dv


************
FUNC vorjahr_valid(d, dv)

dv := vorjahr(d)
refr_gl()

RETURN .t.


****************
FUNC txt_open()
#ifdef USE_POSTGRES
LOCAL cTable:="txt", cFilt:="benutzer==" + Quote(PADR(UPPER(netuser),4)) + " .OR. benutzer==" + Quote(systextuser)
USE (cTable) ALIAS txt VIA (cDBECDX) SHARED NEW
_OrdListAdd(cTable)
ORDSETFOCUS("usertname")
SET FILTER TO &cFilt
RETURN .t.
#else
// Datei txt.dbf ffnen
LOCAL lRet:=.f., cFile:=si_path + "\txt",;
      cFilt:="benutzer==" + Quote(PADR(UPPER(netuser),4)) + " .OR. benutzer==" + Quote(systextuser)
IF !FILE(cFile + ".dbf")
    ALERT("Datei " + cFile + ".dbf konnte nicht geffnet werden!;" +;
          "Bitte Systemadministrator informieren (vermutlich Netzwerkproblem)!")
    oDBServerSession:disconnect()
    QUIT   // Sofort beenden ohne Quit_App() - weitere Schaden vermeiden!
/*
    DBCREATE(cFile, {  {"user","C",4,0},;       // Login-Name
                       {"tname","C",10,0},;     // Text-Name
                       {"txt_d","M",10,0},;     // deutscher Text
                       {"txt_e","M",10,0} },;   // englischer Text
                       cDBECDX)
*/
END
USE (cFile) ALIAS txt VIA (cDBECDX) SHARED NEW
IF lRet:=NETERR()
    ALERT(ne4 + cFile)
ELSE
    IF FILE(cFile + ".cdx")
        _OrdListAdd(cFile)
    ELSE
        INDEX ON benutzer + tname TAG usertname TO (cFile + ".cdx")
    END
END
ORDSETFOCUS("usertname")
SET FILTER TO &cFilt
RETURN !lRet
#endif


****************
FUNC get_txt(cTName, nLang)
LOCAL owa:=SELECT(), lFound:=.f., cRet:=""

cTName := PADR(UPPER(cTName), 10)
SELECT txt
DBGOTOP()
IF DBSEEK(systextuser + cTName) .OR. DBSEEK(PADR(UPPER(netuser), 4) + cTName)
    cRet := (IIF(nLang==1, txt->txt_d, txt->txt_e))
END
SELECT (owa)
RETURN cRet


****************
PROC txt_browse(lPaste)
// Tabelle Texte
STATIC lTxtBrowse:=.f.
LOCAL owa:=SELECT(), aft:="", wi:={}, cTitle:=IIF(lPaste, "Text Einfgen", "Texte")
PRIVATE browseBl:={|| txtbr()}, funcBl:=IIF(lPaste, {|| paste_txtfu() }, {|| txtfu() })

IF !lTxtBrowse   // Avoid crash e.g. if ALT+T used within txt_edit()
    lTxtBrowse := .t.
    SELECT txt
    DBGOTOP()
    aft := futa(IIF(lPaste, {}, {"4 Edit", "6 Neu", "8 Lsch"}))   // , "5 Kopie"
    upn(cTitle)
    wi:=swopen(1,0,AppMaxRow-1,AppMaxCol)
    txt->(sibrowse(0,0,MAXROW(),MAXCOL(),,.f.))
    swclose(wi)
    restfuta(aft)
    SELECT (owa)
    lTxtBrowse := .f.
END
RETURN


***********
PROC txtbr()
LOCAL oColumn, cColors:=SetColor(), i:=2, pos:=0, nColWidth:=40
DO WHILE .T.
    pos := AT(",", cColors, pos+1)
    IF pos == 0
        EXIT
    END
    i++
ENDDO
browse:colorSpec := cColors + ",R+/B,R/BG"
oColumn := TBColumnNew("Text-Name",   {|| tname} )
oColumn:colorBlock := {|nValue| IIf( benutzer==systextuser, {i,i+1}, {1,2} ) }
browse:addColumn(oColumn)
browse:addColumn(TBColumnNew("deutsch",   {|| DotDotDot(MEMOLINE(txt_d, TAB_BREITE, 1), nColWidth)}))
browse:addColumn(TBColumnNew("englisch",  {|| DotDotDot(MEMOLINE(txt_e, TAB_BREITE, 1), nColWidth)}))
RETURN


***********
PROC txtfu()
DO CASE
    CASE nKey==K_ESC
        lMore:=.f.
/*
    CASE nKey==K_F3
        txt_such()               // Text suchen
*/
    CASE nKey==K_F4
        txt_edit()
/*
    CASE nKey==K_F5
        txt_neu(.t.)
*/
    CASE nKey==K_F6
        txt_neu(.f.)

    CASE nKey==K_F8
        IF benutzer==systextuser
            ALERT("System-Texte drfen nicht gelscht werden!")
        ELSEIF ALERT("Text lschen?", jn)==1 .AND. myRLock()
            DBDELETE()
            DBUNLOCK()
        END
/*
    CASE nKey==K_ALT_O
        setorder()              // Reihenfolge setzen
*/
END
RETURN


***********
PROC paste_txtfu()
LOCAL nCol:=browse:colPos, oNameCol:=browse:getColumn(1), cName:=EVAL(oNameCol:block),;
      cText:=get_txt(cName, IIF(ncol==3, 2, 1)), oCB, lOK:=.f.
DO CASE
    CASE nKey==K_ESC
        lMore:=.f.
    CASE nKey==K_ENTER
        oCB := XbpClipBoard():new()
        IF oCB:open()
            IF oCB:clear()
                lOK := oCB:setBuffer(cText, XBPCLPBRD_TEXT)
            END
            oCB:close()
        END
        oCB:destroy()
        IF lOK
            DoPaste()
        END
        lMore:=.f.
END
RETURN


**************
FUNC RemoveSoftCR(cMemoText)
RETURN STRTRAN(cMemoText, CHR(141), CHR(13))


*******************
PROC txt_edit()
// Editfenster fr Texte
LOCAL aft:="", wi:={}, cTName:=txt->tname

IF myRLock()
    wi:=swopen(1,3,17,78, "Text bearbeiten")
    DISPBEGIN()
    aft:=futa({})
    SETCURSOR(1)

    IF benutzer==systextuser
        @ 1,0 SAY "Name:   "
        @ Row(),Col() SAY txt->tname COLOR "R+/B"
    ELSE
        @ 1,0 SAY "Name:   " GET cTName PICTURE "@!" VALID tname_unique(cTName)
    END
    @ 3,0 SAY "Deutsch:"
    disp_zt(txt->txt_d, 4, 0, TAB_BREITE)
    @ 9,0 SAY "Englisch:"
    disp_zt(txt->txt_e, 10, 0, TAB_BREITE)
    DISPEND()
    READ

    SETCOLOR(farbe7)
    txt->txt_d := RemoveSoftCR(MEMOEDIT(txt->txt_d, 4, 0, 7, TAB_BREITE-1, .t., "m_udf", TAB_BREITE))
    disp_zt(txt->txt_d, 4, 0, TAB_BREITE)    // falls verworfen
    txt->txt_e := RemoveSoftCR(MEMOEDIT(txt->txt_e, 10, 0, 13, TAB_BREITE-1, .t., "m_udf", TAB_BREITE))
    DBCOMMIT()
    DBUNLOCK()

    restfuta(aft)
    swclose(wi)
END
RETURN


*********************
FUNC tname_unique(cTName)
//Test ob cTName bereits existiert (in txt.dbf)
LOCAL lRet:=.f., nRec:=RECNO()
IF !DBSEEK(systextuser + cTName)
    lRet := !DBSEEK(PADR(UPPER(netuser),4) + cTName)
    IF !lRet
        IF nRec == RECNO()  // Seek last match if current record was found
            DBSEEK(PADR(UPPER(netuser),4) + cTName,,, .t.)
            lRet := (nRec == RECNO())
        END
    END
END
DBGOTO(nRec)
IF lRet
    txt->tname := cTName
ELSE
    ALERT("Text-Name '" + ALLTRIM(cTName) + "' existiert bereits")
END
RETURN lRet


*******************
PROC txt_neu(lCopy)
LOCAL nRec:=RECNO()
//LOCAL cTName:=txt->tname, cTxt_d:=txt->txt_d, cTxt_e:=txt->txt_e

IF myAppend()
    browse:cargo:=.f.
    txt->benutzer := netuser
    txt->txt_d := " "
    txt->txt_e := " "   // Browser-Spalte leer wenn nicht zugewiesen!
/*
    IF lCopy
        txt->tname := cTName
        txt->txt_d := cTxt_d
        txt->txt_e := cTxt_e
    END
*/
    DBCOMMIT()
    DBUNLOCK()
    txt_edit()
ELSE
    DBGOTO(nRec)
END
RETURN


************
FUNC pdf_existiert(cPath, cName)
RETURN (!EMPTY(cName) .AND. FEXISTS(cPath + IIF(RIGHT(cPath,1)=="\","","\") + cName + "*.PDF"))


************
FUNC pdf_anzeigen(cPath, cName)
LOCAL nRet:=0, aDir:={}, cDir:=cPath+IIF(RIGHT(cPath,1)=="\","","\"), cPDF:=""

IF !EMPTY(cName)
    aDir := DIRECTORY(cDir + cName + "*.PDF")
    nRet := LEN(aDir)
    IF nRet == 0
        ALERT("Keine passende PDFs gefunden!")
    ELSE
        FOR i := 1 TO nRet
            cPDF := cDir + aDir[i, 1]
            RUN ("CMD /C START " + Quote(cPDF) + " " + Quote(cPDF))  // PDF-Datei anzeigen mit Windows-Standardprogramm
        NEXT
    END
END
RETURN nRet


***************
FUNC testpath(cPath)
//Test, ob Pfad existiert bzw. angelegt werden konnte
LOCAL lRet:=.f., aFeld:={}, nPos:=0

WHILE lRet:=EMPTY(FILESEEK(cPath,16))    //,.t.
    nPos:=RAT("\", cPath)
    IF nPos<4
        EXIT
    ELSE
        AADD(aFeld, SUBSTR(cPath, nPos))
        cPath:=LEFT(cPath, nPos-1)
    END
END
lRet:=.t.
nPos:=LEN(aFeld)
WHILE nPos > 0
    cPath += aFeld[nPos--]
    lRet:=(DIRMAKE(cPath)==0)
    IF !lRet
        ALERT("Kann Verzeichnis nicht erzeugen;" + cPath)
        EXIT
    END
END
RETURN lRet


***************
FUNC SaveRelations()
// Save and clear relations for the current work-area
LOCAL i, iMax:=DbInfo(DBO_RELATIONS), aRelations:={}

FOR i = 1 TO iMax
    AADD(aRelations, {ALIAS(DbRSelect(i)), DBRelation(i)})
NEXT

DBCLEARRELATION()

RETURN aRelations


***************
PROC RestoreRelations(aRelations)
// Clear and restore relations for the current work-area
LOCAL i, iMax:=Len(aRelations), cAlias:="", cRelation:=""

DBCLEARRELATION()

FOR i = 1 TO iMax
    cAlias := aRelations[i][1]
    cRelation := aRelations[i][2]
    SET RELATION TO &(cRelation) INTO &(cAlias) ADDITIVE
NEXT

RETURN
