//////////////////////////////////////////////////////////////////////
//
//  MDICUST.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2019. Alle Rechte vorbehalten.         
//  
//  Inhalt:
//      Definiert Kunden-Eingabemaske fr MDIDEMO.EXE
//////////////////////////////////////////////////////////////////////



#include "Xbp.ch"
#include "Mdidemo.ch"
#include "Appevent.ch"


/*
 * Kunden Dialog
 */
PROCEDURE Customer( nRecno )
   LOCAL oXbp, oStatic, drawingArea, oDlg, oFocus, bContextMenu, aStatic := {}
   FIELD CUSTNO, MR_MRS, LASTNAME, FIRSTNAME, STREET, CITY, ZIP , ;
         PHONE , FAX   , NOTES   , BLOCKED  , TOTALSALES

   IF ! OpenCustomer( nRecno )       // Kundendatenbank ffnen
      RETURN
   ENDIF

   oDlg := DataDialog():new( GetApplication():MainForm:DrawingArea, , ;
                             NIL , {605,315},, .F.  )
   oDlg:title := "Kunden Nr: "+ LTrim( CUSTNO )
   oDlg:icon  := ICON_CUSTOMER
   oDlg:create()

   oDlg:seekOrder := 2               // Daten fr den "Suchen" Dialog
   oDlg:seekExpr  := {|x| Upper(x) } // -> SeekDialog
   oDlg:seekFields:= {"LASTNAME","FIRSTNAME"}
   oDlg:seekTitle := "Nachnamen suchen"

   drawingArea := oDlg:drawingArea   // Anzeigebereich vom Dialog holen
   drawingArea:setFontCompoundName( "8.Helv" )

   // Kontextmen mit rechtem Mausklick aktivieren
   bContextMenu       := {|mp1,mp2,obj| SetAppFocus( oDlg )           , ;
                                        ContextMenu():cargo := oDlg   , ;
                                        ContextMenu():popup( obj, mp1 ) }
   drawingArea:RbDown := bContextMenu

   oStatic := XbpStatic():new( drawingArea ,, {12,227}, {579,58} )
   oStatic:type := XBPSTATIC_TYPE_GROUPBOX
   oStatic:create()
   AAdd( aStatic, oStatic )

   oXbp := XbpStatic():new( oStatic ,, {9,14}, {80,22} )
   oXbp:caption := "Kunden Nr:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,14}, {68,22} )
   oXbp:bufferLength := 6
   oXbp:tabStop  := .T.
   oXbp:group    := XBP_BEGIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, LTrim(CUSTNO), CUSTNO := PadL(Trim(x),6) ) }

   // KundenNr darf nur einmal existieren
   oXbp:validate := {|o| oDlg:isIndexUnique( 1, Padl(Trim(o:editBuffer()),6) ) }
   oXbp:create():setData()

   oDlg:addEditControl( oXbp )       // Xbp als EditControl und
   oDlg:addAppendControl( oXbp )     // AppendControl registrieren

   IF ! Eof()                        // KundenNr kann nur bei
      oXbp:disable()                 // Neuanlage editiert werden
   ELSE
      oFocus := oXbp
   ENDIF

   oXbp := XbpCheckbox():new( oStatic,, {209,14}, {94,20} )
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, BLOCKED, BLOCKED := x ) }
   oXbp:caption := "Gesperrt"
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )       // Xbp als EditControl registrieren

   oXbp := XbpStatic():new( oStatic,, {339,14}, {80,22} )
   oXbp:caption := "Umsatz:"
   oXbp:options  := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {426,14}, {144,22} )
   oXbp:bufferLength := 8
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Transform(TOTALSALES, "@N"), TOTALSALES := Val(x) ) }
   oXbp:create():setData()
   oXbp:disable()
   oDlg:addEditControl( oXbp )

   oStatic := XbpStatic():new( drawingArea,, {11,14}, {288,208} )
   oStatic:type := XBPSTATIC_TYPE_GROUPBOX
   oStatic:create()
   AAdd( aStatic, oStatic )

   oXbp := XbpStatic():new( oStatic,, {5,165}, {80,22} )
   oXbp:caption := "Anrede:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,165}, {180,22} )
   oXbp:bufferLength := 20
   oXbp:tabStop  := .T.
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(MR_MRS), MR_MRS := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oXbp := XbpStatic():new( oStatic,, {5,135}, {80,22} )
   oXbp:caption := "Nachname:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,135}, {180,22} )
   oXbp:bufferLength := 20
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(LASTNAME), LASTNAME := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   IF ! Eof()
      oFocus := oXbp
   ENDIF

   oXbp := XbpStatic():new( oStatic,, {5,105}, {80,22} )
   oXbp:caption := "Vorname:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,105}, {180,22} )
   oXbp:bufferLength := 20
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(FIRSTNAME), FIRSTNAME := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oXbp := XbpStatic():new( oStatic,, {5,75}, {80,22} )
   oXbp:caption := "Strae:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,75}, {178,22} )
   oXbp:bufferLength := 30
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(STREET), STREET := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oXbp := XbpStatic():new( oStatic,, {5,45}, {80,22} )
   oXbp:caption := "PLZ:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,45}, {60,22} )
   oXbp:bufferLength := 5
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(ZIP), ZIP := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oXbp := XbpStatic():new( oStatic,, {5,15}, {80,22} )
   oXbp:caption := "Stadt:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,15}, {180,22} )
   oXbp:bufferLength := 30
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, CITY, CITY := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oStatic := XbpStatic():new( drawingArea,, {315,14}, {276,209} )
   oStatic:caption := "Notiz:"
   oStatic:type := XBPSTATIC_TYPE_GROUPBOX
   oStatic:create()
   AAdd( aStatic, oStatic )

   oXbp := XbpMle():new( oStatic,, {7,70}, {253,115} )
   oXbp:dataLink := {|x| IIf( x==NIL, NOTES, NOTES := x ) }
   oXbp:ignoreTab:= .T.
   oXbp:tabStop  := .T.
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oXbp := XbpStatic():new( oStatic,, {7,40}, {80,22} )
   oXbp:caption := "Telefon:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,40}, {140,22} )
   oXbp:bufferLength := 15
   oXbp:tabStop  := .T.
   oXbp:group    := XBP_WITHIN_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(PHONE), PHONE := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   oXbp := XbpStatic():new( oStatic,, {7,10}, {80,22} )
   oXbp:caption := "Fax:"
   oXbp:options := XBPSTATIC_TEXT_RIGHT
   oXbp:create()
   AAdd( aStatic, oXbp )

   oXbp := XbpSLE():new( oStatic,, {95,10}, {140,22} )
   oXbp:bufferLength := 15
   oXbp:group    := XBP_END_GROUP
   oXbp:dataLink := {|x| IIf( x==NIL, Trim(FAX), FAX := x ) }
   oXbp:create():setData()
   oDlg:addEditControl( oXbp )

   AEval( aStatic, {|o| o:rbDown := bContextMenu } )

   oDlg:show()
   oDlg:contextMenu := ContextMenu()
   oDlg:windowMenu  := WinMenu()
   WinMenu():addItem( oDlg )

   // Neuen Titel in Codeblock erzeugen, wenn sich Datensatz ndert
   oDlg:newTitle := {|obj| ;
        obj:setTitle( "Kunden Nr: "+LTrim(CUSTNO) ), ;
        WinMenu():setItem( obj ) }
   WinMenu():checkItem( oDlg )

   oDlg:currentControl := oFocus
   SetAppFocus( oDlg )

RETURN



/*
 * Kundendatenbank ffnen
 */
FUNCTION OpenCustomer( nRecno )
   LOCAL nOldArea := Select(), lDone := .F.

   USE Customer NEW
   IF ! NetErr()
      SET INDEX TO CustA, CustB
      IF nRecno <> NIL
         DbGoto( nRecno )
      ENDIF

      lDone := .T.
   ELSE
      DbSelectArea( nOldArea )
      MsgBox( "Tabelle kann nicht geffnet werden" )
   ENDIF

RETURN lDone



/*
 * Kontextmen fr Kundendialog erzeugen
 */
STATIC FUNCTION ContextMenu()
   STATIC soMenu

   IF soMenu == NIL
      soMenu       := DataDialogMenu():new()
      soMenu:title := "Kunden Kontextmen"
      soMenu:create()

   ENDIF

RETURN soMenu
