****************************************************************
*   sima.ch
*   Headerfile fr Sima/ Fibu
*
*   SINUS Messtechnik GmbH
*   K. Gedicke
*
*   Stand: 05.08.2002
****************************************************************

#include "achoice.ch"
//#include "button.ch"
#include "inkey.ch"
//#include "ord.ch"
#include "setcurs.ch"
#include "Fileio.ch"
#include "memoedit.ch"
#include "dbstruct.ch"

#ifdef __XPP__
#include "appevent.ch"
#include "xbp.ch"
#include "dmlb.ch"
#include "adsdbe.ch"
#include "cdxdbe.ch"
#include "foxdbe.ch"
//#include "simaarc.ch"
/*==============================================================================
Redefinitions of MEMOLINE() and MLCOUNT() (see MyMemoLine in xBaseZusatz.prg)
avoid known bugs (see PDRs 3690 & 5531, respectively, in Alaska knowledge base).
===============================================================================*/
#xtranslate MEMOLINE(<Params,...>) ;
       => MyMemoLine(<Params>)
#xtranslate MLCOUNT(<cString> [,<nLineLen>] [,<nTabSize>] [,<lWrap>]) ;
     =>  MyMemoLine(<cString>, <nLineLen>, -1, <nTabSize>, <lWrap>)


#ifndef USE_POSTGRES
/*==============================================================================
Redefinitions for efficient use of ADS (s. xBaseZusatz.prg).
===============================================================================*/
#xcommand SET FILTER TO ;
       => AX_ClearFilter()
#xcommand SET FILTER TO <x> ;
       => AX_SetFilter( <(x)> )
#xtranslate DBCLEARFILTER() ;
       => AX_ClearFilter()
#xtranslate DBFILTER() ;
       => AX_GetFilter()
#xtranslate DBSETFILTER(<b>, <c>) ;
       => AX_SetFilter( <c> )
/* SCOPE redefinitions unnecessary?
#command SET SCOPETOP TO                => OrdScope( 0, nil )
#command SET SCOPETOP TO <x>            => OrdScope( 0, <x> )

#command SET SCOPEBOTTOM TO             => OrdScope( 1, nil )
#command SET SCOPEBOTTOM TO <x>         => OrdScope( 1, <x> )

#command SET SCOPE TO                   => OrdScope( 0, nil );
                                         ; OrdScope( 1, nil )
#command SET SCOPE TO <x>, <y>          => OrdScope( 0, <x> );
                                         ; OrdScope( 1, <y> )
#command SET SCOPE TO <x>               => OrdScope( 0, <x> );
                                         ; OrdScope( 1, <x> )
#command SET SCOPE TO ,<x>              => OrdScope( 1, <x> )
*/
#endif


/*==============================================================================
                     Alaska PDR 2615 (s. xbasezusatz.prg)
Symptom:
oGet:original always has the same value as oGet:buffer
Description:
The instance variable of the GET class :original has not the value of the
original variable as described in the documentation.
It gets the value of :buffer. So the undo() function won't work.
The workaround described in the former PDR 657 to use :getVar()
doesn't work too.
===============================================================================*/
#command  @ <nRow>, <nCol> GET <Var> ;
                       [PICTURE <cPict>] ;
                         [VALID <lValid>] ;
                          [WHEN <lWhen>] ;
                          [SEND <message>] ;
       =>  aadd( getList, ;
      ( GetX():new( <nRow>, <nCol>, __gBlock(<Var>), __gName(<Var>), ;
                  <cPict>, NIL, <{lValid}>, <{lWhen}>) ):display() ) ;
        [; Atail( getList ):<message>]
/*==============================================================================
Redefinition of ALERT for GUI mode (s. xBaseZusatz.prg).
===============================================================================*/
#ifdef GUI
#xtranslate ALERT(<cMeldung> [, <aOptionen>]) ;
       => AlertBox(, <cMeldung>, <aOptionen>, , programname)
#endif  // GUI
#define INFOCHAR    CHR(254)
#else   // Clipper
#define INFOCHAR    CHR(4)
#endif  // __XPP__

#define MAXLINES    60          // Druckzeilen pro Seite (58)
#define EXTRALINES  3           // Extra-Druckzeilen ab 2. Seite (fngt hher an!)
#define HDRLINES    7           // Header-Druckzeilen ab 2. Seite
#define PLINE_LEN   108         // Zeilenlnge in Ranger-Partlist
#define D_MWST      19          // Voreinstellung Mehrwertsteuersatz
#define CUR         "EUR"
#define TAB_BREITE  70          // Zeilenlnge fr Formulare
#define LENMEMO     45          // Zeilenlnge Zusatztext (Angebot, Auftrag)
#define WRAPMEMO    LENMEMO     // ZT Word-Wrap-Parameter fr MEMOEDIT
#define SNHRABATT   "999906.2"  // Sachnummer fr Hndler-Rabatt
#define SNBWARTSN   "999968.1"  // Sachnummer fr Bestellwunsch
#define SNBWSL_ID   "999969.8"  // Sachnummer fr Bestellwnsche (anstelle von Stckliste)
#define SNAZAPMIN   "999971.2"  // Sachnummer fr Minutensatz Produktion
#define FBKNRAUFPOS 2           // Dynamisch generierte FBK/MP fr Auftragspositionen
#define IBAN_PIC    "@R! NNNN NNNN NNNN NNNN NNNN NNNN NNNN NNNN NN"
                                // PICTURE fr IBAN-Anzeige/-Eingabe
#define K_HASH      ASC("#")    // Taste fr Seriennummerverwaltung auf Auftragspositio
