*********************************************************************
*     SIMA.PRG
*     Materialverwaltung
*     SINUS Messtechnik GmbH, K. Gedicke
*     Start: Februar 1993
*     Stand: 13.07.2001 (in CVS 2005)
*********************************************************************

#include "sima.ch"

#ifndef __XPP__
REQUEST DBFCDX
#endif

******************
PROC main()
//Initialisierung
//Parameter: Name/Pfad Konfig.-Datei
LOCAL wi:={}, cConfigText:=""
#ifdef __XPP__
LOCAL nEvent, mp1, mp2, oXbp
LOCAL aMenus:={}, aSubMenus:={}, cMenu:=""
#endif
PARAMETERS cConfig, cConfig2, cConfig3
IF cConfig == "simawin"             // Nur wegen xppdbg unter Windows 7...
    cConfig := cConfig2
    cConfig2 := cConfig3
END
IF cConfig == "/I"
    cConfig := NIL
    cConfig2 := "/I"
END
IF cConfig == NIL
    cConfig := "C:\sima\Test\SIMAPG\simawin.cfg"
END

ProgInit("SIMAWI")

IF cConfig2 == "/I"
    Alle_Indexe()
ELSE
    //Login-Name prfen, Zugriffsrechte und vollen Namen einlesen
    IF !seek_user()
        Quit_App()
    END
    IF user_open()
        Check_Tagesbeginn(1)
        IF DBSEEK(netuser)
            IF myRLock()
                IF user->dat_sima < date()
                    user->dat_sima := date()
                    user->in_sima := 1
                ELSE
                    user->in_sima := IIF(user->in_sima >= 9, 1, user->in_sima + 1)
                END
                DBCOMMIT()
                DBUNLOCK()
            ELSE
                ALERT("Satzsperre gescheitert fr Benutzer " + user->benutzer +;
                      ";in_sima = " + user->in_sima)
            END
        ELSE
            ALERT("Benutzer (" + netuser + ") nicht gefunden!")
        END
        CLOSE user
    ELSE
        ALERT("Benutzerdatei konnte nicht geffnet werden!")
    END

    IF open_artikel();                  //artikel.dbf
        .AND. open_param();             //param.dbf
        .AND. open_anlief();            //anlief.dbf
        .AND. lk_open();                //lk.dbf
        .AND. txt_open();               //txt.dbf
        .AND. artser_open();            //artser.dbf
        .AND. artserau_open()           //artserau.dbf

        Check_Tagesbeginn(2)

        SETKEY(K_ALT_T, {|| txt_browse(.t.) })  // Text auswhlen und einfgen
        SETKEY(K_ALT_F10, {|| lk() })   // Tabelle Lieferanten-/ Kunden
        SET KEY K_F1 TO help()

        fill_fidx()                     // ggf. fidx.dbf erzeugen
#ifndef GUI
        wi:=swopen(2,48,5,78, "Login")
        @ 0,0 SAY "ID:   " + TRIM(netuser)
        @ 1,0 SAY "Name: " + TRIM(username)
        wselect(wi[1])
#endif
        oMenuBar:=MenuCreate(farbe8)          // Hauptmenaufruf
#ifdef __XPP__
#ifdef GUI
        SetAppEvent(xbeM_RbClick, {|| DoPaste()})
        oCrt:setTitle(programname + " " + programversion +;
                      " - " + TRIM(netuser) + " (" + TRIM(username) + ")")
#endif
        SetAppEvent(xbeK_ALT_F7, NIL)  // Fensterverschiebung unterdrcken
        aMenus := DC_MM_aMenus(oMenuBar)
        aSubMenus := DC_MM_aSubMenus(oMenuBar)
        WHILE lAppRun
            KEYBOARD ""    // Clear buffer to avoid possible ESC loop
            cMenu := DC_MENUMAIN( { 0, 2, "N/BG,W+/BG,GR+/BG,W+/N,N+/W", 'AAD', ;
                                    .t., cMenu, ;
                                    aMenus, aSubMenus, ;
                                    '', .f., 0, 0, {}, .f., ;
                                    {MAXROW(),0,0,MAXROW(),0,MAXROW(),MAXCOL()} } )
        END
#else
        nid:=1
        WHILE (nid:=MENUMODAL(oMenuBar, nid,24,1,78, farbe2)) <> 999
            oMenuBar:Select(1)
        END
#endif
#ifndef GUI
        swclose(wi)
#endif
    END
END

Quit_App()

RETURN


***********************
PROC Alle_Indexe()
// Alle gemeinsame und SIMA-spezifische DBFs kurz ffnen um Indexe zu erzeugen falls ntig (z.B. automatisch gelscht beim Update)

open_anlief()
CLOSE anlief
open_artikel()
CLOSE lager
best_open()
CLOSE bb
bepos_open()
CLOSE be
fbk_open()
CLOSE fbk
open_fidx()
CLOSE fidx
lk_open()   // nLenFirma1, in lk_open() initialisiert, wird in open_hedi1() bentigt
CLOSE lk
open_hedi1()
CLOSE hed1
open_hedi2()
CLOSE hed2
help_open()
CLOSE help
korr_open()
CLOSE korr
lo_open()
CLOSE lo
ls_open()
CLOSE ls
lspos_open()
CLOSE lspos
mp_open()
CLOSE mp
mppos_open()
CLOSE mppos
open_param()
CLOSE be_daten
prod_open()
CLOSE prod
pz_open()
CLOSE pz
slv_open()
CLOSE sl_verz
user_open()
CLOSE user
wa_open()
CLOSE wa
we_open()
CLOSE we
land_open()
CLOSE land
waehrung_open()
CLOSE waehrung
artlog_open()
CLOSE artlog
lklog_open()
CLOSE lklog
txt_open()
CLOSE txt
bw_open()
CLOSE bw
artser_open()
CLOSE artser
artserau_open()
CLOSE artserau

RETURN


****************************************************************
//Men

****************************
FUNC MenuCreate(cFarbe1)
LOCAL oTopBar, oPopUp

oTopBar := TopBar( 0, 2, 62)
oTopBar:ColorSpec := cFarbe1

oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1

oPopUp:AddItem(MenuItem( "&Artikel" ,{|| artikel() },,;
                         "Tabelle Artikel",1))
oPopUp:AddItem(MenuItem( "&Produkte" ,{|| produkt() },,;
                         "Tabelle Produkte",1))
oPopUp:AddItem(MenuItem( "&Stcklisten" ,{|| slv(.f.) },,;
                         "Tabelle Stcklisten",1))
oPopUp:AddItem(MenuItem( "Auf&trge" ,{|| auftrag() },,;
                         "Tabelle Auftrge",1))
oPopUp:AddItem(MenuItem( "&Fertigungsauftrge" ,{|| fbk() },,;
                         "Tabelle Fertigungsauftrge",1))
oPopUp:AddItem(MenuItem( "&Materialprojekte" ,{|| matprj(.f.) },,;
                         "Tabelle Materialprojekte",1))
oPopUp:AddItem(MenuItem( "&Bestellungen" ,{|| bb() },,;
                         "Tabelle Bestellungen",1))
IF bw_allowed()
    oPopUp:AddItem(MenuItem( "B&estellwnsche" ,{|| bw() },,;
                             "Tabelle Bestellwnsche",1))
END
oPopUp:AddItem(MenuItem( "&Lieferscheine" ,{|| ls() },,;
                         "Tabelle Lieferscheine",1))
oPopUp:AddItem(MenuItem( "Lieferanten/ &Kunden" ,{|| lk() },,;
                         "Tabelle Lieferanten/ Kunden",1))
oPopUp:AddItem(MenuItem( "Lager&orte" ,{|| lagerort() },,;
                         "Tabelle Lagerorte",1))
oPopUp:AddItem(MenuItem( "Serien&nummern" ,{|| artser(.f.) },,;
                         "Tabelle Seriennummern",1))
IF lsup
    oPopUp:AddItem(MenuItem( "Be&nutzer" ,{|| usertab() },,;
                             "Tabelle Benutzer",1))
END
oTopBar:AddItem( MenuItem ( "&Tabellen ",oPopUp) )


oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1

oPopUp:AddItem(MenuItem( "&Standard" ,{|| std_such() },,;
                         "Suchen nach Artikelbezeichnung/ Parameter",2))
oPopUp:AddItem(MenuItem( "&Matchcode" ,{|| mc_such() },,;
                         "Suchen nach Matchcode",2))
oPopUp:AddItem(MenuItem( "&Bestellbezeichnung" ,{|| bb_such() },,;
                         "Suchen nach Bestellbezeichnung",2))
oPopUp:AddItem(MenuItem( "&Outline" ,{|| ou_such() },,;
                         "Suchen nach Outline",2))
oTopBar:AddItem( MenuItem ( "&Suchen ",oPopUp) )


oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1

oPopUp:AddItem(MenuItem( "&Inventur Lager" ,{|| inv() },,;
                         "Ermittlung des Lagerbestandes",3))
oPopUp:AddItem(MenuItem( "Inventur &Bereitstellung" ,{|| inv2() },,;
                         "Inventur des bereitgestellten Materials",3))
oPopUp:AddItem(MenuItem( "Bestell&termine" ,{|| be_termin() },,;
                         "Liefertermine fr offene Bestellungen",3))
oPopUp:AddItem(MenuItem( "&Gruppenzugehrigkeit" ,{|| ingruppe() },,;
                         "Liste der Artikel zu einer Auswahl von Baugruppen",3))
oPopUp:AddItem(MenuItem( "&SL-Zugehrigkeit" ,{|| insl() },,;
                         "Liste der Artikel, die in Baugruppen vorkommen",3))
oTopBar:AddItem( MenuItem ( "&Reports ",oPopUp) )


oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1

oPopUp:AddItem(MenuItem( "Waren&eingang" ,{|| we_log() },,;
                         "Log-Datei Wareneingang",4))
oPopUp:AddItem(MenuItem( "Waren&ausgang" ,{|| wa_log() },,;
                         "Log-Datei Warenausgang",4))
oPopUp:AddItem(MenuItem( "&Bestandskorrektur" ,{|| korr_log() },,;
                         "Log-Datei Bestandskorrektur",4))
oTopBar:AddItem( MenuItem ( "&Log-Dateien ",oPopUp) )


oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1

oPopUp:AddItem(MenuItem( "&Hersteller" ,{|| herst() },,;
                         "Zuordnung Distributoren zu Herstellern",5))
oPopUp:AddItem(MenuItem( "&Distributoren" ,{|| distr() },,;
                         "Zuordnung Hersteller zu Distributoren",5))
oPopUp:AddItem(MenuItem( CHR(196) ))
oPopUp:AddItem(MenuItem( "&Whrungen" ,{|| waehrung_edit() },,;
                         "Whrungen mit EUR-Kursen",5))
oPopUp:AddItem(MenuItem( CHR(196) ))
oPopUp:AddItem(MenuItem( "Erzeuge &fidx.dbf" ,{|| rebuildfidx() },,;
                         "Artikel-Stcklisten-Zuordnung neu bilden (fidx.dbf)",5))
oPopUp:AddItem(MenuItem( "&Prfpolynom" ,{|| pp_disp() },,;
                         "Prfziffer ermitteln",5))
oPopUp:AddItem(MenuItem( "&E-Reihe" ,{|| e_reihe() },,;
                         "Eingabe einer E-Reihe",5))
oPopUp:AddItem(MenuItem( CHR(196) ))
oPopUp:AddItem(MenuItem( "Schrift&art" ,{|| SelectFont() },,;
                         "Schriftart whlen",5))
oPopUp:AddItem(MenuItem( CHR(196) ))
oPopUp:AddItem(MenuItem( "&Texte" ,{|| txt_browse(.f.) },,;
                         "Tabelle Texte",5))
oPopUp:AddItem(MenuItem( CHR(196) ))
oPopUp:AddItem(MenuItem( "ber &Sima" ,{|| simainfo() },,;
                         "Info zum Programm",5))
oTopBar:AddItem( MenuItem ( "&Extras ",oPopUp) )


oPopUp := PopUp()
oPopUp :ColorSpec:= cFarbe1
#ifdef __XPP__
oPopUp:AddItem(MenuItem( "&Beenden" ,{|| lAppRun := .f. },,;
                         "Programm beenden", 999))
#else
oPopUp:AddItem(MenuItem( "&Beenden" ,{|| .t. },,;
                         "Programm beenden", 999))
#endif

oTopBar:AddItem( MenuItem ( "&Beenden" + SPACE(AppMaxCol-75), oPopUp) )

RETURN oTopBar


**************
PROC usertab()
//Tabelle User/ Zugriffsrechte
LOCAL wi:={}, aft:=""
PRIVATE funcbl:={|| utfu()}, browsebl:={|| utbr()}
IF user_open() .AND. DBSEEK(netuser) .AND. zr(lSup==.t.)
    aft:=futa({"6 Neu","8 Lsch"})
    upn("Tabelle Benutzer")
    DBGOTOP()
    wi:=swopen(1,0,AppMaxRow-1,AppMaxCol)
    sibrowse()
    swclose(wi)
    restfuta(aft)
    CLOSE user
END
RETURN


***********
PROC utbr()
browse:addColumn(TBColumnNew("Login", {|| benutzer } ))
browse:addColumn(TBColumnNew("Benutzername", FIELDBLOCK("name") ))
browse:addColumn(TBColumnNew("in", FIELDBLOCK("in_fibu") ))
browse:addColumn(TBColumnNew("FIBU am", FIELDBLOCK("dat_fibu") ))
browse:addColumn(TBColumnNew("in", FIELDBLOCK("in_sima") ))
browse:addColumn(TBColumnNew("SIMA am", FIELDBLOCK("dat_sima") ))
browse:addColumn(TBColumnNew("Ang", FIELDBLOCK("nrAng") ))
browse:addColumn(TBColumnNew("Auf", FIELDBLOCK("nrAuf") ))
browse:addColumn(TBColumnNew("Art ", FIELDBLOCK("nrArt") ))
browse:addColumn(TBColumnNew("FA", FIELDBLOCK("nrFa") ))
browse:addColumn(TBColumnNew("Fib", FIELDBLOCK("nrFibu") ))
browse:addColumn(TBColumnNew("LK", FIELDBLOCK("nrLk") ))
browse:addColumn(TBColumnNew("LO", FIELDBLOCK("nrLo") ))
browse:addColumn(TBColumnNew("LS", FIELDBLOCK("nrLs") ))
browse:addColumn(TBColumnNew("MP  ", FIELDBLOCK("nrMp") ))
browse:addColumn(TBColumnNew("SL  ", FIELDBLOCK("nrSl") ))
browse:addColumn(TBColumnNew("lHelp", FIELDBLOCK("lhelp") ))
browse:addColumn(TBColumnNew("lSup", FIELDBLOCK("lsup") ))
RETURN


***********
PROC utfu()
DO CASE
    CASE nKey==K_ESC            //Tabelle schlieen
        lMore:=.f.

    CASE nKey==K_F6             //neuen Benutzer anlegen
        ut_new()

    CASE nKey==K_F8             //Benutzer lschen
        IF ALERT("Benutzer lschen: " + TRIM(benutzer), jn)==1 .AND. myRLock()
            DBDELETE()
            DBCOMMIT()
            DBUNLOCK()
        END

    CASE nKey==K_ALT_F10
        lk()                    //Tabelle Lieferanten/ Kunden ffnen

    CASE nKey==K_RETURN
        DoGet(Browse)           //direkte Eingabe in die Tabelle

    OTHERWISE
        KEYBOARDX(CHR(nKey))
        DoGet(Browse)           //direkte Eingabe in die Tabelle
END
RETURN


*************
PROC ut_new()
//neuen Benutzer anlegen
LOCAL wi:={}, _user:=SPACE(4)
wi:=swopen(10,20,14,59, "Neuen Benutzer anlegen", farbe3)
DISPBEGIN()
SETCOLOR(farbe2)
@ 1,1 SAY "Login-Name: " GET _user;
      PICTURE "@!" VALID !EMPTY(benutzer)
DISPEND()
READ
swclose(wi)
IF UPDATED()
    DBAPPEND()
    user->benutzer:=_user
    DBUNLOCK()
END
RETURN


***************
PROC simainfo()
//Fenster mit Programminfo
LOCAL wi:=swopen(6,10,22,69, "Info", farbe3), n:=0
SETCOLOR(farbe2)
n:=MAXCOL()
@ 2,0 SAY PADC(programname + " Version " + programversion, n) COLOR farbe5
@ 3,0 SAY PADC("Materialverwaltung", n)
@ 5,0 SAY PADC("SINUS Messtechnik GmbH", n)
@ 6,0 SAY PADC("Fpplstrae 13", n)
@ 7,0 SAY PADC("04347 Leipzig", n)
@ 9,0 SAY PADC(cConfig, n)
@10,0 SAY PADC("Printer=" + cPrinter, n)
@11,0 SAY PADC("WinDrucker=" + cWinDrucker, n)
@13,0 SAY PADC("QUIT", n) COLOR farbe3
inkey(0)
swclose(wi)
RETURN
